searchNodes=[{"type":"module","title":"K8s","doc":"Kubernetes API Client for Elixir","ref":"K8s.html"},{"type":"function","title":"K8s.default_cacertfile/0","doc":"Returns the default CAStore","ref":"K8s.html#default_cacertfile/0"},{"type":"function","title":"K8s.default_discovery_driver/0","doc":"Returns the default driver for discovery. Each K8s.Conn can have its own driver set. If unset, this value will be used. Defaults to K8s.Discovery.Driver.HTTP Example mix config In the example below dev and test clusters will use the File driver, while prod will use the HTTP driver. Cluster names can be atoms or strings, but are internally stored as strings. use Mix.Config config :k8s , discovery_driver : K8s.Discovery.Driver.File , discovery_opts : [ config : &quot;test/support/discovery/example.json&quot; ]","ref":"K8s.html#default_discovery_driver/0"},{"type":"function","title":"K8s.default_discovery_opts/0","doc":"Returns default opts for the discovery driver. This is also configurable per K8s.Conn","ref":"K8s.html#default_discovery_opts/0"},{"type":"function","title":"K8s.default_http_provider/0","doc":"Returns the default HTTP Provider","ref":"K8s.html#default_http_provider/0"},{"type":"module","title":"K8s.Client","doc":"Kubernetes API Client. Functions return K8s.Operation s that represent kubernetes operations. To run operations pass them to: run/2 , or run/3 When specifying kinds the format should either be in the literal kubernetes kind name (eg &quot;ServiceAccount&quot; ) or the downcased version seen in kubectl (eg &quot;serviceaccount&quot; ). A string or atom may be used. Examples &quot;Deployment&quot; , &quot;deployment&quot; , :Deployment , :deployment &quot;ServiceAccount&quot; , &quot;serviceaccount&quot; , :ServiceAccount , :serviceaccount &quot;HorizontalPodAutoscaler&quot; , &quot;horizontalpodautoscaler&quot; , :HorizontalPodAutoscaler , :horizontalpodautoscaler http_opts to K8s.Client.Runner modules are K8s.Client.HTTPProvider HTTP options.","ref":"K8s.Client.html"},{"type":"function","title":"K8s.Client.apply/2","doc":"Returns a PATCH operation to server-side-apply the given resource. K8s Docs : Examples Apply a deployment with management parameteres iex&gt; deployment = K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) ...&gt; K8s.Client . apply ( deployment , field_manager : &quot;my-operator&quot; , force : true ) % K8s.Operation { method : :patch , verb : :patch , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] , data : K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) , query_params : [ fieldManager : &quot;my-operator&quot; , force : true ] , header_params : [ &quot;Content-Type&quot; : &quot;application/apply-patch+yaml&quot; ] , }","ref":"K8s.Client.html#apply/2"},{"type":"function","title":"K8s.Client.apply/5","doc":"Returns a PATCH operation to server-side-apply the given subresource given a resource's details and a subresource map. Examples Apply a status to a pod: iex&gt; pod_with_status_subresource = K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-pod.yaml&quot; ) |&gt; Map . put ( &quot;status&quot; , %{ &quot;message&quot; =&gt; &quot;some message&quot; } ) ...&gt; K8s.Client . apply ( &quot;v1&quot; , &quot;pods/status&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , pod_with_status_subresource , field_manager : &quot;my-operator&quot; , force : true ) % K8s.Operation { method : :patch , verb : :patch , api_version : &quot;v1&quot; , name : &quot;pods/status&quot; , path_params : [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , data : K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-pod.yaml&quot; ) |&gt; Map . put ( &quot;status&quot; , %{ &quot;message&quot; =&gt; &quot;some message&quot; } ) , query_params : [ fieldManager : &quot;my-operator&quot; , force : true ] , header_params : [ &quot;Content-Type&quot; : &quot;application/apply-patch+yaml&quot; ] }","ref":"K8s.Client.html#apply/5"},{"type":"function","title":"K8s.Client.async/2","doc":"alias of K8s.Client.Runner.Async.run/3","ref":"K8s.Client.html#async/2"},{"type":"function","title":"K8s.Client.async/3","doc":"alias of K8s.Client.Runner.Async.run/3","ref":"K8s.Client.html#async/3"},{"type":"function","title":"K8s.Client.connect/4","doc":"Returns a CONNECT operation for a pods/exec resource by version, kind/resource type, name, and optionally namespace. K8s Docs : Examples connect to the nginx deployment in the test namespace: iex&gt; K8s.Client . connect ( &quot;apps/v1&quot; , &quot;pods/exec&quot; , [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] , command : &quot;ls&quot; ) % K8s.Operation { method : :post , verb : :connect , api_version : &quot;apps/v1&quot; , name : &quot;pods/exec&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] , query_params : [ { :stdin , true } , { :stdout , true } , { :stderr , true } , { :tty , false } , { :command , &quot;ls&quot; } ] }","ref":"K8s.Client.html#connect/4"},{"type":"function","title":"K8s.Client.create/1","doc":"Returns a POST K8s.Operation to create the given resource. Examples iex&gt; deployment = K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) ...&gt; K8s.Client . create ( deployment ) % K8s.Operation { method : :post , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] , verb : :create , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , data : K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) }","ref":"K8s.Client.html#create/1"},{"type":"function","title":"K8s.Client.create/2","doc":"Returns a POST K8s.Operation to create the given subresource. Used for creating subresources like Scale or Eviction . Examples Evicting a pod iex&gt; pod = K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-pod.yaml&quot; ) ...&gt; eviction = K8s.Resource . from_file! ( &quot;test/support/manifests/eviction-policy.yaml&quot; ) ...&gt; K8s.Client . create ( pod , eviction ) % K8s.Operation { api_version : &quot;v1&quot; , data : K8s.Resource . from_file! ( &quot;test/support/manifests/eviction-policy.yaml&quot; ) , method : :post , name : { &quot;Pod&quot; , &quot;Eviction&quot; } , path_params : [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , verb : :create }","ref":"K8s.Client.html#create/2"},{"type":"function","title":"K8s.Client.create/4","doc":"Returns a POST K8s.Operation to create the given subresource. Used for creating subresources like Scale or Eviction . Examples Evicting a pod iex&gt; eviction = K8s.Resource . from_file! ( &quot;test/support/manifests/eviction-policy.yaml&quot; ) ...&gt; K8s.Client . create ( &quot;v1&quot; , &quot;pods/eviction&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , eviction ) % K8s.Operation { api_version : &quot;v1&quot; , method : :post , name : &quot;pods/eviction&quot; , path_params : [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , verb : :create , data : K8s.Resource . from_file! ( &quot;test/support/manifests/eviction-policy.yaml&quot; ) }","ref":"K8s.Client.html#create/4"},{"type":"function","title":"K8s.Client.delete/1","doc":"Returns a DELETE operation for a resource by manifest. May be a partial manifest as long as it contains: apiVersion kind metadata.name metadata.namespace (if applicable) K8s Docs : Delete will delete a resource. Depending on the specific resource, child objects may or may not be garbage collected by the server. See notes on specific resource objects for details. Examples iex&gt; deployment = K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) ...&gt; K8s.Client . delete ( deployment ) % K8s.Operation { method : :delete , verb : :delete , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] }","ref":"K8s.Client.html#delete/1"},{"type":"function","title":"K8s.Client.delete/3","doc":"Returns a DELETE operation for a resource by version, kind, name, and optionally namespace. Examples iex&gt; K8s.Client . delete ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : &quot;test&quot; , name : &quot;nginx&quot; ) % K8s.Operation { method : :delete , verb : :delete , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] }","ref":"K8s.Client.html#delete/3"},{"type":"function","title":"K8s.Client.delete_all/2","doc":"Returns a DELETE collection operation for all instances of a cluster scoped resource kind. Examples iex&gt; K8s.Client . delete_all ( &quot;extensions/v1beta1&quot; , &quot;PodSecurityPolicy&quot; ) % K8s.Operation { method : :delete , verb : :deletecollection , api_version : &quot;extensions/v1beta1&quot; , name : &quot;PodSecurityPolicy&quot; , path_params : [ ] } iex&gt; K8s.Client . delete_all ( &quot;storage.k8s.io/v1&quot; , &quot;StorageClass&quot; ) % K8s.Operation { method : :delete , verb : :deletecollection , api_version : &quot;storage.k8s.io/v1&quot; , name : &quot;StorageClass&quot; , path_params : [ ] }","ref":"K8s.Client.html#delete_all/2"},{"type":"function","title":"K8s.Client.delete_all/3","doc":"Returns a DELETE collection operation for all instances of a resource kind in a specific namespace. Examples iex&gt; K8s.Client . delete_all ( &quot;apps/v1beta1&quot; , &quot;ControllerRevision&quot; , namespace : &quot;default&quot; ) % K8s.Operation { method : :delete , verb : :deletecollection , api_version : &quot;apps/v1beta1&quot; , name : &quot;ControllerRevision&quot; , path_params : [ namespace : &quot;default&quot; ] } iex&gt; K8s.Client . delete_all ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : &quot;staging&quot; ) % K8s.Operation { method : :delete , verb : :deletecollection , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ namespace : &quot;staging&quot; ] }","ref":"K8s.Client.html#delete_all/3"},{"type":"function","title":"K8s.Client.get/1","doc":"Returns a GET operation for a resource given a Kubernetes manifest. May be a partial manifest as long as it contains: apiVersion kind metadata.name metadata.namespace (if applicable) K8s Docs : Get will retrieve a specific resource object by name. Examples Getting a pod iex&gt; pod = %{ ...&gt; &quot;apiVersion&quot; =&gt; &quot;v1&quot; , ...&gt; &quot;kind&quot; =&gt; &quot;Pod&quot; , ...&gt; &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx-pod&quot; , &quot;namespace&quot; =&gt; &quot;test&quot; } , ...&gt; &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot; } } ...&gt; } ...&gt; K8s.Client . get ( pod ) % K8s.Operation { method : :get , verb : :get , api_version : &quot;v1&quot; , name : &quot;Pod&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx-pod&quot; ] , }","ref":"K8s.Client.html#get/1"},{"type":"function","title":"K8s.Client.get/3","doc":"Returns a GET operation for a resource by version, kind/resource type, name, and optionally namespace. K8s Docs : Get will retrieve a specific resource object by name. Examples Get the nginx deployment in the default namespace: iex&gt; K8s.Client . get ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : &quot;test&quot; , name : &quot;nginx&quot; ) % K8s.Operation { method : :get , verb : :get , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] } Get the nginx deployment in the default namespace by passing the kind as atom. iex&gt; K8s.Client . get ( &quot;apps/v1&quot; , :deployment , namespace : &quot;test&quot; , name : &quot;nginx&quot; ) % K8s.Operation { method : :get , verb : :get , api_version : &quot;apps/v1&quot; , name : :deployment , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] } Get the nginx deployment's status: iex&gt; K8s.Client . get ( &quot;apps/v1&quot; , &quot;deployments/status&quot; , namespace : &quot;test&quot; , name : &quot;nginx&quot; ) % K8s.Operation { method : :get , verb : :get , api_version : &quot;apps/v1&quot; , name : &quot;deployments/status&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] } Get the nginx deployment's scale: iex&gt; K8s.Client . get ( &quot;v1&quot; , &quot;deployments/scale&quot; , namespace : &quot;test&quot; , name : &quot;nginx&quot; ) % K8s.Operation { method : :get , verb : :get , api_version : &quot;v1&quot; , name : &quot;deployments/scale&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] }","ref":"K8s.Client.html#get/3"},{"type":"function","title":"K8s.Client.list/3","doc":"Returns a GET operation to list all resources by version, kind, and namespace. Given the namespace :all as an atom, will perform a list across all namespaces. K8s Docs : List will retrieve all resource objects of a specific type within a namespace, and the results can be restricted to resources matching a selector query. List All Namespaces: Like List but retrieves resources across all namespaces. Examples iex&gt; K8s.Client . list ( &quot;v1&quot; , &quot;Pod&quot; , namespace : &quot;default&quot; ) % K8s.Operation { method : :get , verb : :list , api_version : &quot;v1&quot; , name : &quot;Pod&quot; , path_params : [ namespace : &quot;default&quot; ] } iex&gt; K8s.Client . list ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : :all ) % K8s.Operation { method : :get , verb : :list_all_namespaces , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ ] }","ref":"K8s.Client.html#list/3"},{"type":"function","title":"K8s.Client.parallel/3","doc":"alias of K8s.Client.Runner.Async.run/3","ref":"K8s.Client.html#parallel/3"},{"type":"function","title":"K8s.Client.patch/1","doc":"Returns a PATCH operation to patch the given resource. K8s Docs : Patch will apply a change to a specific field. How the change is merged is defined per field. Lists may either be replaced or merged. Merging lists will not preserve ordering. Patches will never cause optimistic locking failures, and the last write will win. Patches are recommended when the full state is not read before an update, or when failing on optimistic locking is undesirable. When patching complex types, arrays and maps, how the patch is applied is defined on a per-field basis and may either replace the field's current value, or merge the contents into the current value. Examples iex&gt; deployment = K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) ...&gt; K8s.Client . patch ( deployment ) % K8s.Operation { method : :patch , verb : :patch , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] , data : K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) , header_params : [ &quot;Content-Type&quot; : &quot;application/merge-patch+json&quot; ] }","ref":"K8s.Client.html#patch/1"},{"type":"function","title":"K8s.Client.patch/2","doc":"","ref":"K8s.Client.html#patch/2"},{"type":"function","title":"K8s.Client.patch/3","doc":"Returns a PATCH operation to patch the given subresource given a resource map and a subresource map.","ref":"K8s.Client.html#patch/3"},{"type":"function","title":"K8s.Client.patch/5","doc":"Returns a PATCH operation to patch the given subresource given a resource's details and a subresource map.","ref":"K8s.Client.html#patch/5"},{"type":"function","title":"K8s.Client.put_conn/2","doc":"See K8s.Operation.put_conn/2 .","ref":"K8s.Client.html#put_conn/2"},{"type":"function","title":"K8s.Client.run/1","doc":"alias of K8s.Client.Runner.Base.run/1","ref":"K8s.Client.html#run/1"},{"type":"function","title":"K8s.Client.run/2","doc":"alias of K8s.Client.Runner.Base.run/2","ref":"K8s.Client.html#run/2"},{"type":"function","title":"K8s.Client.run/3","doc":"alias of K8s.Client.Runner.Base.run/3","ref":"K8s.Client.html#run/3"},{"type":"function","title":"K8s.Client.stream/1","doc":"alias of K8s.Client.Runner.Stream.run/1","ref":"K8s.Client.html#stream/1"},{"type":"function","title":"K8s.Client.stream/2","doc":"alias of K8s.Client.Runner.Stream.run/2","ref":"K8s.Client.html#stream/2"},{"type":"function","title":"K8s.Client.stream/3","doc":"alias of K8s.Client.Runner.Stream.run/3","ref":"K8s.Client.html#stream/3"},{"type":"function","title":"K8s.Client.stream_to/2","doc":"alias of K8s.Client.Runner.StreamTo.run/2","ref":"K8s.Client.html#stream_to/2"},{"type":"function","title":"K8s.Client.stream_to/3","doc":"alias of K8s.Client.Runner.StreamTo.run/3","ref":"K8s.Client.html#stream_to/3"},{"type":"function","title":"K8s.Client.stream_to/4","doc":"alias of K8s.Client.Runner.StreamTo.run/4","ref":"K8s.Client.html#stream_to/4"},{"type":"function","title":"K8s.Client.update/1","doc":"Returns a PUT operation to replace/update the given resource. K8s Docs : Replacing a resource object will update the resource by replacing the existing spec with the provided one. For read-then-write operations this is safe because an optimistic lock failure will occur if the resource was modified between the read and write. Note: The ResourceStatus will be ignored by the system and will not be updated. To update the status, one must invoke the specific status update operation. Note: Replacing a resource object may not result immediately in changes being propagated to downstream objects. For instance replacing a ConfigMap or Secret resource will not result in all Pods seeing the changes unless the Pods are restarted out of band. Examples iex&gt; deployment = K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) ...&gt; K8s.Client . update ( deployment ) % K8s.Operation { method : :put , verb : :update , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] , data : K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) }","ref":"K8s.Client.html#update/1"},{"type":"function","title":"K8s.Client.update/2","doc":"Returns a PUT operation to replace/update the given subresource given a resource map and a subresource map. Used for updating subresources like Scale or Status . Examples Scaling a deployment: iex&gt; deployment = K8s.Resource . from_file! ( &quot;test/support/manifests/nginx-deployment.yaml&quot; ) ...&gt; scale = K8s.Resource . from_file! ( &quot;test/support/manifests/scale-replicas.yaml&quot; ) ...&gt; K8s.Client . update ( deployment , scale ) % K8s.Operation { api_version : &quot;apps/v1&quot; , method : :put , path_params : [ namespace : &quot;test&quot; , name : &quot;nginx&quot; ] , verb : :update , data : K8s.Resource . from_file! ( &quot;test/support/manifests/scale-replicas.yaml&quot; ) , name : { &quot;Deployment&quot; , &quot;Scale&quot; } }","ref":"K8s.Client.html#update/2"},{"type":"function","title":"K8s.Client.update/4","doc":"Returns a PUT operation to replace/update the given subresource given a resource's details and a subresource map. Used for updating subresources like Scale or Status . Examples Scaling a deployment iex&gt; scale = K8s.Resource . from_file! ( &quot;test/support/manifests/scale-replicas.yaml&quot; ) ...&gt; K8s.Client . update ( &quot;apps/v1&quot; , &quot;deployments/scale&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , scale ) % K8s.Operation { api_version : &quot;apps/v1&quot; , data : K8s.Resource . from_file! ( &quot;test/support/manifests/scale-replicas.yaml&quot; ) , method : :put , name : &quot;deployments/scale&quot; , path_params : [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , verb : :update }","ref":"K8s.Client.html#update/4"},{"type":"function","title":"K8s.Client.wait_until/2","doc":"alias of K8s.Client.Runner.Wait.run/2","ref":"K8s.Client.html#wait_until/2"},{"type":"function","title":"K8s.Client.wait_until/3","doc":"alias of K8s.Client.Runner.Wait.run/3","ref":"K8s.Client.html#wait_until/3"},{"type":"function","title":"K8s.Client.watch/3","doc":"Returns a GET operation to list all resources by version, kind, and namespace. Given the namespace :all as an atom, will perform a list across all namespaces. K8s Docs : List will retrieve all resource objects of a specific type within a namespace, and the results can be restricted to resources matching a selector query. List All Namespaces: Like List but retrieves resources across all namespaces. Examples iex&gt; K8s.Client . list ( &quot;v1&quot; , &quot;Pod&quot; , namespace : &quot;default&quot; ) % K8s.Operation { method : :get , verb : :list , api_version : &quot;v1&quot; , name : &quot;Pod&quot; , path_params : [ namespace : &quot;default&quot; ] } iex&gt; K8s.Client . list ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : :all ) % K8s.Operation { method : :get , verb : :list_all_namespaces , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; , path_params : [ ] }","ref":"K8s.Client.html#watch/3"},{"type":"type","title":"K8s.Client.path_param/0","doc":"","ref":"K8s.Client.html#t:path_param/0"},{"type":"type","title":"K8s.Client.path_params/0","doc":"","ref":"K8s.Client.html#t:path_params/0"},{"type":"module","title":"K8s.Client.DynamicHTTPProvider","doc":"Allows for registration of K8s.Client.Provider handlers per-process. Used internally by the test suite for testing/mocking Kubernetes responses.","ref":"K8s.Client.DynamicHTTPProvider.html"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"K8s.Client.DynamicHTTPProvider.html#child_spec/1"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.list/0","doc":"List all registered handlers","ref":"K8s.Client.DynamicHTTPProvider.html#list/0"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.locate/1","doc":"Locate the handler module for this process or any ancestor","ref":"K8s.Client.DynamicHTTPProvider.html#locate/1"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.register/2","doc":"Register the handler mdoule for this process","ref":"K8s.Client.DynamicHTTPProvider.html#register/2"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.request/5","doc":"Dispatch request/5 to the module registered in the current process or any ancestor.","ref":"K8s.Client.DynamicHTTPProvider.html#request/5"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.start_link/1","doc":"Starts this provider.","ref":"K8s.Client.DynamicHTTPProvider.html#start_link/1"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.stream/5","doc":"Dispatch stream_to/6 to the module registered in the current process or any ancestor.","ref":"K8s.Client.DynamicHTTPProvider.html#stream/5"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.stream_to/6","doc":"Dispatch stream_to/6 to the module registered in the current process or any ancestor.","ref":"K8s.Client.DynamicHTTPProvider.html#stream_to/6"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.websocket_request/3","doc":"Dispatch request/5 to the module registered in the current process or any ancestor.","ref":"K8s.Client.DynamicHTTPProvider.html#websocket_request/3"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.websocket_stream/3","doc":"Dispatch request/5 to the module registered in the current process or any ancestor.","ref":"K8s.Client.DynamicHTTPProvider.html#websocket_stream/3"},{"type":"function","title":"K8s.Client.DynamicHTTPProvider.websocket_stream_to/4","doc":"Dispatch request/5 to the module registered in the current process or any ancestor.","ref":"K8s.Client.DynamicHTTPProvider.html#websocket_stream_to/4"},{"type":"module","title":"K8s.Client.HTTPStream","doc":"Helper functions for HTTP stream processing.","ref":"K8s.Client.HTTPStream.html"},{"type":"function","title":"K8s.Client.HTTPStream.decode_json_objects/1","doc":"","ref":"K8s.Client.HTTPStream.html#decode_json_objects/1"},{"type":"function","title":"K8s.Client.HTTPStream.transform_to_lines/1","doc":"","ref":"K8s.Client.HTTPStream.html#transform_to_lines/1"},{"type":"type","title":"K8s.Client.HTTPStream.to_lines_t/0","doc":"","ref":"K8s.Client.HTTPStream.html#t:to_lines_t/0"},{"type":"module","title":"K8s.Client.HTTPTestHelper","doc":"HTTP Helpers for test suite.","ref":"K8s.Client.HTTPTestHelper.html"},{"type":"function","title":"K8s.Client.HTTPTestHelper.render/1","doc":"","ref":"K8s.Client.HTTPTestHelper.html#render/1"},{"type":"function","title":"K8s.Client.HTTPTestHelper.render/2","doc":"","ref":"K8s.Client.HTTPTestHelper.html#render/2"},{"type":"function","title":"K8s.Client.HTTPTestHelper.stream_object/1","doc":"","ref":"K8s.Client.HTTPTestHelper.html#stream_object/1"},{"type":"module","title":"K8s.Client.Mint.ConnectionRegistry","doc":"A registry for open connections. As HTTP/2 allows simultaneous requests, we handle multiple requests with one process. In this case, the registry stores the PID of the HTTPAdapter which is connected according to the given connection details (URI/opts). HTTP/1 only allows one request per connection at a time. In order to support simultaneous requests, we need a connection pool. This is where the :poolboy library comes in.","ref":"K8s.Client.Mint.ConnectionRegistry.html"},{"type":"function","title":"K8s.Client.Mint.ConnectionRegistry.checkin/1","doc":"","ref":"K8s.Client.Mint.ConnectionRegistry.html#checkin/1"},{"type":"function","title":"K8s.Client.Mint.ConnectionRegistry.checkout/1","doc":"ets a HTTPAdapter process from the registry. If the returned process is an adapter pool, an adapter is checked out from the pool and a map with both PIDs is returned. If the returned process is an adapter process, a map with its PID and pool set to nil is returned.","ref":"K8s.Client.Mint.ConnectionRegistry.html#checkout/1"},{"type":"function","title":"K8s.Client.Mint.ConnectionRegistry.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"K8s.Client.Mint.ConnectionRegistry.html#child_spec/1"},{"type":"function","title":"K8s.Client.Mint.ConnectionRegistry.start_link/1","doc":"Starts the registry.","ref":"K8s.Client.Mint.ConnectionRegistry.html#start_link/1"},{"type":"type","title":"K8s.Client.Mint.ConnectionRegistry.adapter_pool_t/0","doc":"","ref":"K8s.Client.Mint.ConnectionRegistry.html#t:adapter_pool_t/0"},{"type":"type","title":"K8s.Client.Mint.ConnectionRegistry.adapter_type_t/0","doc":"","ref":"K8s.Client.Mint.ConnectionRegistry.html#t:adapter_type_t/0"},{"type":"type","title":"K8s.Client.Mint.ConnectionRegistry.uriopts/0","doc":"","ref":"K8s.Client.Mint.ConnectionRegistry.html#t:uriopts/0"},{"type":"module","title":"K8s.Client.Mint.HTTPAdapter","doc":"The Mint client implementation. This module handles both, HTTP requests and websocket connections. Processes The module creates a process per connection to the Kubernetes API server. It supports HTTP/2 for HTTP requests, but not for websockets. So while an open connection can process multiple requests (if the server supports HTTP/2 ), it can only process one single websocket connection. Therefore, each websocket connection is handled in its own process. State The module keeps track of the Mint.HTTP connection struct and a map of pending requests ( K8s.Client.Mint.Request ) for that connection, indexed by the Mint.Types.request_ref() . Requests Requests are calls to the GenServer that immediately return while the GenServer receives the response parts in the background. The way these response parts are returned depends on the state_to argument passed to request/7 resp. websocket_request/5 . See these function's docs for more details.","ref":"K8s.Client.Mint.HTTPAdapter.html"},{"type":"function","title":"K8s.Client.Mint.HTTPAdapter.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"K8s.Client.Mint.HTTPAdapter.html#child_spec/1"},{"type":"function","title":"K8s.Client.Mint.HTTPAdapter.connection_args/2","doc":"Returns connection arguments for the given URI and HTTP options.","ref":"K8s.Client.Mint.HTTPAdapter.html#connection_args/2"},{"type":"function","title":"K8s.Client.Mint.HTTPAdapter.open?/2","doc":"","ref":"K8s.Client.Mint.HTTPAdapter.html#open?/2"},{"type":"function","title":"K8s.Client.Mint.HTTPAdapter.recv/2","doc":"Returns response parts / frames that were buffered by the process. The stream_to must have been set to nil in request/7 or websocket_request/5 . If the buffer is empty, this call blocks until the next response part / frame is received.","ref":"K8s.Client.Mint.HTTPAdapter.html#recv/2"},{"type":"function","title":"K8s.Client.Mint.HTTPAdapter.request/7","doc":"Starts a HTTP request. The way the response parts are returned depends on the stream_to argument passed to it. nil - response parts are buffered. In order to receive them, the caller needs to recv/2 passing it the request_ref returned by this function. pid - response parts are sent to the process with the given pid . {pid, reference} - response parts are sent to the process with the given pid . Messages are of the form {reference, response_part} .","ref":"K8s.Client.Mint.HTTPAdapter.html#request/7"},{"type":"function","title":"K8s.Client.Mint.HTTPAdapter.start_link/1","doc":"Opens a connection to Kubernetes, defined by uri and opts , and starts the GenServer.","ref":"K8s.Client.Mint.HTTPAdapter.html#start_link/1"},{"type":"function","title":"K8s.Client.Mint.HTTPAdapter.websocket_request/5","doc":"Upgrades to a Websocket connection. The way the frames are returned depends on the stream_to argument passed to it. nil - frames are buffered. In order to receive them, the caller needs to recv/2 passing it the request_ref returned by this function. pid - frames are sent to the process with the given pid . {pid, reference} - frames are sent to the process with the given pid . Messages are of the form {reference, response_part} .","ref":"K8s.Client.Mint.HTTPAdapter.html#websocket_request/5"},{"type":"function","title":"K8s.Client.Mint.HTTPAdapter.websocket_send/3","doc":"Sends the given data throught the websocket specified by the request_ref .","ref":"K8s.Client.Mint.HTTPAdapter.html#websocket_send/3"},{"type":"type","title":"K8s.Client.Mint.HTTPAdapter.connection_args_t/0","doc":"","ref":"K8s.Client.Mint.HTTPAdapter.html#t:connection_args_t/0"},{"type":"type","title":"K8s.Client.Mint.HTTPAdapter.t/0","doc":"Describes the state of the connection. :conn - The current state of the Mint connection. :requests - The opened requests over this connection (Only HTTP/2 connections will hold multiple entries in this field.)","ref":"K8s.Client.Mint.HTTPAdapter.html#t:t/0"},{"type":"module","title":"K8s.Client.Mint.Request","doc":"Maintains the state of a HTTP or Websocket request.","ref":"K8s.Client.Mint.Request.html"},{"type":"function","title":"K8s.Client.Mint.Request.map_frame/1","doc":"","ref":"K8s.Client.Mint.Request.html#map_frame/1"},{"type":"function","title":"K8s.Client.Mint.Request.map_outgoing_frame/1","doc":"","ref":"K8s.Client.Mint.Request.html#map_outgoing_frame/1"},{"type":"function","title":"K8s.Client.Mint.Request.map_response/1","doc":"","ref":"K8s.Client.Mint.Request.html#map_response/1"},{"type":"function","title":"K8s.Client.Mint.Request.maybe_terminate_request/1","doc":"","ref":"K8s.Client.Mint.Request.html#maybe_terminate_request/1"},{"type":"function","title":"K8s.Client.Mint.Request.new/1","doc":"","ref":"K8s.Client.Mint.Request.html#new/1"},{"type":"function","title":"K8s.Client.Mint.Request.put_response/2","doc":"","ref":"K8s.Client.Mint.Request.html#put_response/2"},{"type":"function","title":"K8s.Client.Mint.Request.receive_upgrade_response/2","doc":"","ref":"K8s.Client.Mint.Request.html#receive_upgrade_response/2"},{"type":"function","title":"K8s.Client.Mint.Request.recv/2","doc":"","ref":"K8s.Client.Mint.Request.html#recv/2"},{"type":"function","title":"K8s.Client.Mint.Request.stream_request_body/2","doc":"","ref":"K8s.Client.Mint.Request.html#stream_request_body/2"},{"type":"type","title":"K8s.Client.Mint.Request.request_modes/0","doc":"Describes the mode the request is currently in. ::pending - The request is still streaming its body to the server :receiving - The request is currently receiving response parts / frames :closing - Websocket requests only: The :close frame was received but the process wasn't terminated yet :terminating - HTTP requests only: The :done part was received but the request isn't cleaned up yet","ref":"K8s.Client.Mint.Request.html#t:request_modes/0"},{"type":"type","title":"K8s.Client.Mint.Request.t/0","doc":"Defines the state of the request. :request_ref - Mint request reference :caller_ref - Monitor reference of the calling process. :stream_to - the process expecting response parts sent to. :pool - the PID of the pool so we can checkin after the last part is sent. :websocket - for WebSocket requests: The websocket state ( Mint.WebSocket.t() ). :mode - defines what mode the request is currently in. :buffer - Holds the buffered response parts or frames that haven't been sent to / received by the caller yet :pending_request_body - Part of the request body that has not been sent yet.","ref":"K8s.Client.Mint.Request.html#t:t/0"},{"type":"module","title":"K8s.Client.MintHTTPProvider","doc":"Mint based K8s.Client.Provider","ref":"K8s.Client.MintHTTPProvider.html"},{"type":"behaviour","title":"K8s.Client.Provider","doc":"HTTP Request / Response provider behaviour","ref":"K8s.Client.Provider.html"},{"type":"function","title":"K8s.Client.Provider.headers/1","doc":"Generates HTTP headers from K8s.Conn.RequestOptions Adds {:Accept, &quot;application/json&quot;} to all requests if the header is not set. Examples Sets Content-Type to application/json iex&gt; opts = % K8s.Conn.RequestOptions { headers : [ Authorization : &quot;Basic AF&quot; ] } ...&gt; K8s.Client.HTTPProvider . headers ( opts ) [ Accept : &quot;application/json&quot; , Authorization : &quot;Basic AF&quot; ]","ref":"K8s.Client.Provider.html#headers/1"},{"type":"callback","title":"K8s.Client.Provider.request/5","doc":"Perform HTTP requests","ref":"K8s.Client.Provider.html#c:request/5"},{"type":"callback","title":"K8s.Client.Provider.stream/5","doc":"Perform HTTP requests and returns a stream of response chunks","ref":"K8s.Client.Provider.html#c:stream/5"},{"type":"callback","title":"K8s.Client.Provider.stream_to/6","doc":"Perform HTTP requests and stream response to another process","ref":"K8s.Client.Provider.html#c:stream_to/6"},{"type":"callback","title":"K8s.Client.Provider.websocket_request/3","doc":"Perform HTTP requests","ref":"K8s.Client.Provider.html#c:websocket_request/3"},{"type":"callback","title":"K8s.Client.Provider.websocket_stream/3","doc":"Perform websocket requests and returns a stream of response chunks","ref":"K8s.Client.Provider.html#c:websocket_stream/3"},{"type":"callback","title":"K8s.Client.Provider.websocket_stream_to/4","doc":"Perform websocket requests and returns a stream of response chunks","ref":"K8s.Client.Provider.html#c:websocket_stream_to/4"},{"type":"type","title":"K8s.Client.Provider.error_t/0","doc":"","ref":"K8s.Client.Provider.html#t:error_t/0"},{"type":"type","title":"K8s.Client.Provider.headers/0","doc":"","ref":"K8s.Client.Provider.html#t:headers/0"},{"type":"type","title":"K8s.Client.Provider.http_chunk_t/0","doc":"","ref":"K8s.Client.Provider.html#t:http_chunk_t/0"},{"type":"type","title":"K8s.Client.Provider.response_t/0","doc":"","ref":"K8s.Client.Provider.html#t:response_t/0"},{"type":"type","title":"K8s.Client.Provider.send_callback/0","doc":"","ref":"K8s.Client.Provider.html#t:send_callback/0"},{"type":"type","title":"K8s.Client.Provider.stream_response_t/0","doc":"","ref":"K8s.Client.Provider.html#t:stream_response_t/0"},{"type":"type","title":"K8s.Client.Provider.stream_success_t/0","doc":"","ref":"K8s.Client.Provider.html#t:stream_success_t/0"},{"type":"type","title":"K8s.Client.Provider.stream_to_response_t/0","doc":"","ref":"K8s.Client.Provider.html#t:stream_to_response_t/0"},{"type":"type","title":"K8s.Client.Provider.success_t/0","doc":"","ref":"K8s.Client.Provider.html#t:success_t/0"},{"type":"type","title":"K8s.Client.Provider.websocket_chunk_t/0","doc":"","ref":"K8s.Client.Provider.html#t:websocket_chunk_t/0"},{"type":"type","title":"K8s.Client.Provider.websocket_response_t/0","doc":"","ref":"K8s.Client.Provider.html#t:websocket_response_t/0"},{"type":"type","title":"K8s.Client.Provider.websocket_success_t/0","doc":"","ref":"K8s.Client.Provider.html#t:websocket_success_t/0"},{"type":"module","title":"K8s.Client.Runner.Async","doc":"K8s.Client runner to process a batch of operations in parallel.","ref":"K8s.Client.Runner.Async.html"},{"type":"function","title":"K8s.Client.Runner.Async.run/3","doc":"Runs multiple operations in parallel. Operations will be returned in same order given. Operations will not cease in event of failure. Example Get a list of pods in parallel: pods_to_get = [ %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } , %{ &quot;name&quot; =&gt; &quot;redis&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } ] # Map each one to an individual `GET` operation. operations = Enum . map ( pods_to_get , fn ( %{ &quot;name&quot; =&gt; name , &quot;namespace&quot; =&gt; ns } ) -&gt; K8s.Client . get ( &quot;v1&quot; , &quot;Pod&quot; , namespace : ns , name : name ) end ) # Get the results asynchronously { :ok , conn } = K8s.Conn . from_file ( &quot;test/support/kube-config.yaml&quot; ) results = K8s.Client.Runner.Async . run ( conn , operations )","ref":"K8s.Client.Runner.Async.html#run/3"},{"type":"module","title":"K8s.Client.Runner.Base","doc":"Base HTTP processor for K8s.Client .","ref":"K8s.Client.Runner.Base.html"},{"type":"function","title":"K8s.Client.Runner.Base.run/1","doc":"Runs a K8s.Operation . Examples Note: Examples assume a K8s.Conn was configured named &quot;test&quot; . See K8s.Conn.Config . Running a list pods operation: { :ok , conn } = K8s.Conn . from_file ( &quot;test/support/kube-config.yaml&quot; ) operation = K8s.Client . list ( &quot;v1&quot; , &quot;Pod&quot; , namespace : :all ) { :ok , %{ &quot;items&quot; =&gt; pods } } = K8s.Client . run ( conn , operation ) Running a dry-run of a create deployment operation: deployment = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } , &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;test&quot; } , &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 2 , &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; %{ &quot;image&quot; =&gt; &quot;nginx&quot; , &quot;name&quot; =&gt; &quot;nginx&quot; } } } } } operation = deployment |&gt; K8s.Client . create ( ) |&gt; K8s.Operation . put_query_param ( :dryRun , &quot;all&quot; ) { :ok , conn } = K8s.Conn . from_file ( &quot;test/support/kube-config.yaml&quot; ) { :ok , result } = K8s.Client.Runner.Base . run ( conn , operation )","ref":"K8s.Client.Runner.Base.html#run/1"},{"type":"function","title":"K8s.Client.Runner.Base.run/2","doc":"","ref":"K8s.Client.Runner.Base.html#run/2"},{"type":"function","title":"K8s.Client.Runner.Base.run/3","doc":"Run a connect operation and pass websocket_driver_opts to K8s.Client.WebSocketProvider See run/3","ref":"K8s.Client.Runner.Base.html#run/3"},{"type":"function","title":"K8s.Client.Runner.Base.stream/3","doc":"Runs a K8s.Operation and streams the response.","ref":"K8s.Client.Runner.Base.html#stream/3"},{"type":"function","title":"K8s.Client.Runner.Base.stream_to/4","doc":"Runs a K8s.Operation and streams the response.","ref":"K8s.Client.Runner.Base.html#stream_to/4"},{"type":"type","title":"K8s.Client.Runner.Base.body_t/0","doc":"Acceptable HTTP body types","ref":"K8s.Client.Runner.Base.html#t:body_t/0"},{"type":"type","title":"K8s.Client.Runner.Base.error_t/0","doc":"","ref":"K8s.Client.Runner.Base.html#t:error_t/0"},{"type":"type","title":"K8s.Client.Runner.Base.result_t/0","doc":"","ref":"K8s.Client.Runner.Base.html#t:result_t/0"},{"type":"module","title":"K8s.Client.Runner.Stream","doc":"Takes a K8s.Client.list/3 operation and returns an Elixir Stream of resources.","ref":"K8s.Client.Runner.Stream.html"},{"type":"function","title":"K8s.Client.Runner.Stream.run/1","doc":"Validates operation type before calling stream/3 . Only supports verbs: list_all_namespaces and list .","ref":"K8s.Client.Runner.Stream.html#run/1"},{"type":"function","title":"K8s.Client.Runner.Stream.run/2","doc":"","ref":"K8s.Client.Runner.Stream.html#run/2"},{"type":"function","title":"K8s.Client.Runner.Stream.run/3","doc":"","ref":"K8s.Client.Runner.Stream.html#run/3"},{"type":"module","title":"K8s.Client.Runner.Stream.ListRequest","doc":":list K8s.Operation encapsulated with pagination and K8s.Conn","ref":"K8s.Client.Runner.Stream.ListRequest.html"},{"type":"function","title":"K8s.Client.Runner.Stream.ListRequest.next_item/1","doc":"","ref":"K8s.Client.Runner.Stream.ListRequest.html#next_item/1"},{"type":"function","title":"K8s.Client.Runner.Stream.ListRequest.stream/3","doc":"","ref":"K8s.Client.Runner.Stream.ListRequest.html#stream/3"},{"type":"type","title":"K8s.Client.Runner.Stream.ListRequest.continue_t/0","doc":"Pagination continue token","ref":"K8s.Client.Runner.Stream.ListRequest.html#t:continue_t/0"},{"type":"type","title":"K8s.Client.Runner.Stream.ListRequest.responses_t/0","doc":"","ref":"K8s.Client.Runner.Stream.ListRequest.html#t:responses_t/0"},{"type":"type","title":"K8s.Client.Runner.Stream.ListRequest.t/0","doc":"List operation as a Stream data type","ref":"K8s.Client.Runner.Stream.ListRequest.html#t:t/0"},{"type":"module","title":"K8s.Client.Runner.Stream.Watch","doc":"Watches a K8s.Client.list/3 operation and returns an Elixir Stream of events.","ref":"K8s.Client.Runner.Stream.Watch.html"},{"type":"function","title":"K8s.Client.Runner.Stream.Watch.stream/3","doc":"Watches resources and returns an Elixir Stream of events emmitted by kubernetes. Example iex&gt; { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; , [ context : &quot;docker-desktop&quot; ] ) ...&gt; op = K8s.Client . list ( &quot;v1&quot; , &quot;Namespace&quot; ) ...&gt; K8s.Client.Runner.Watch.Stream . stream ( conn , op , [ ] ) |&gt; Stream . map ( &amp; IO . inspect / 1 ) |&gt; Stream . run ( )","ref":"K8s.Client.Runner.Stream.Watch.html#stream/3"},{"type":"type","title":"K8s.Client.Runner.Stream.Watch.t/0","doc":"","ref":"K8s.Client.Runner.Stream.Watch.html#t:t/0"},{"type":"module","title":"K8s.Client.Runner.StreamTo","doc":"Takes a K8s.Client.list/3 operation and returns an Elixir Stream of resources.","ref":"K8s.Client.Runner.StreamTo.html"},{"type":"function","title":"K8s.Client.Runner.StreamTo.run/2","doc":"Validates operation type before calling stream/3 . Only supports verbs: list_all_namespaces and list .","ref":"K8s.Client.Runner.StreamTo.html#run/2"},{"type":"function","title":"K8s.Client.Runner.StreamTo.run/3","doc":"","ref":"K8s.Client.Runner.StreamTo.html#run/3"},{"type":"function","title":"K8s.Client.Runner.StreamTo.run/4","doc":"","ref":"K8s.Client.Runner.StreamTo.html#run/4"},{"type":"module","title":"K8s.Client.Runner.Wait","doc":"Waiting functionality for K8s.Client . Note: This is built using repeated GET operations rather than using a watch operation w/ fieldSelector .","ref":"K8s.Client.Runner.Wait.html"},{"type":"function","title":"K8s.Client.Runner.Wait.run/2","doc":"Continually perform a GET based operation until a condition is met. Example This follow example will wait 60 seconds for the field status.succeeded to equal 1 . op = K8s.Client . get ( &quot;batch/v1&quot; , :job , namespace : &quot;default&quot; , name : &quot;sleep&quot; ) opts = [ find : [ &quot;status&quot; , &quot;succeeded&quot; ] , eval : 1 , timeout : 60 ] { :ok , conn } = K8s.Conn . from_file ( &quot;test/support/kube-config.yaml&quot; ) resp = K8s.Client.Runner.Wait . run ( conn , op , opts )","ref":"K8s.Client.Runner.Wait.html#run/2"},{"type":"function","title":"K8s.Client.Runner.Wait.run/3","doc":"","ref":"K8s.Client.Runner.Wait.html#run/3"},{"type":"type","title":"K8s.Client.Runner.Wait.t/0","doc":"A wait configuration","ref":"K8s.Client.Runner.Wait.html#t:t/0"},{"type":"module","title":"K8s.Conn","doc":"Handles authentication and connection configuration details for a Kubernetes cluster. The %K8s.Conn{} struct is required in order to run any object against the cluster. Use any of the functions defined in this module to create a %K8s.Conn{} struct and pass it to the functions of K8s.Client . Example { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) { :ok , default_ns } = K8s.Client . get ( &quot;v1&quot; , &quot;Namespace&quot; , name : &quot;default&quot; ) |&gt; K8s.Client . put_conn ( conn ) |&gt; K8s.Client . run ( ) Alternatively, you can pass conn to K8s.Client.run() . { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) op = K8s.Client . get ( &quot;v1&quot; , &quot;Namespace&quot; , name : &quot;default&quot; ) { :ok , default_ns } = K8s.Client . run ( op , conn ) Scenarios If your cluster connection is defined in a file, e.g. ~/.kube/config , use K8s.Conn.from_file/2 . If running in a pod inside the cluster you're connecting to, use K8s.Conn.from_service_account/2 If an environment variable points to a config file, use K8s.Conn.from_env/2","ref":"K8s.Conn.html"},{"type":"function","title":"K8s.Conn.from_env/2","doc":"Generates the configuration from a file whose location is defined by the given env_var . Defaults to KUBECONFIG . Options See from_file/2 . Examples if KUBECONFIG is set: { :ok , conn } = K8s.Conn . from_env ( ) Pass the env variable name: { :ok , conn } = K8s.Conn . from_env ( &quot;TEST_KUBECONFIG&quot; ) Pass the env variable name and options: { :ok , conn } = K8s.Conn . from_env ( &quot;TEST_KUBECONFIG&quot; , insecure_skip_tls_verify : true )","ref":"K8s.Conn.html#from_env/2"},{"type":"function","title":"K8s.Conn.from_file/2","doc":"Reads configuration details from a kubernetes config file. If you run your code on your machine, you most likely have a config file at ~/.kube/config . If you created a local cluster using kind , k3d or similar, a context entry is either added to that config file or you saved it to a specific location upon cluster creation. Either way, this function reads the config from any of these files. Example Using the currently selected context: { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) Pass the context and allow insecure TLS verification : { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; , context : &quot;my-kind-cluster&quot; , insecure_skip_tls_verify : true ) Options :context - sets an alternate context - defaults to current-context . :cluster - set or override the cluster read from the context :user - set or override the user read from the context :discovery_driver - module name to use for discovery :discovery_opts - options for discovery module :insecure_skip_tls_verify - Skip TLS verification","ref":"K8s.Conn.html#from_file/2"},{"type":"function","title":"K8s.Conn.from_service_account/2","doc":"Generates the configuration from a Kubernetes service account. This is used when running in a Pod inside the cluster you're accessing. Make sure to setup RBAC for the service account running the Pod. Documentation: kubernetes.io :: Accessing the API from a Pod Options :insecure_skip_tls_verify - Skip TLS verification Example Using the currently selected context: { :ok , conn } = K8s.Conn . from_service_account ( ) You can set a specific path to the service account token file: { :ok , conn } = K8s.Conn . from_service_account ( &quot;/path/to/token&quot; , insecure_skip_tls_verify : true ) Allow insecure TLS verification: { :ok , conn } = K8s.Conn . from_service_account ( insecure_skip_tls_verify : true ) { :ok , conn } = K8s.Conn . from_service_account ( &quot;/path/to/token&quot; , insecure_skip_tls_verify : true )","ref":"K8s.Conn.html#from_service_account/2"},{"type":"type","title":"K8s.Conn.t/0","doc":"cluster_name - The cluster name if read from a kubeconfig file user_name - The user name if read from a kubeconfig file url - The Kubernetes API URL","ref":"K8s.Conn.html#t:t/0"},{"type":"behaviour","title":"K8s.Conn.Auth","doc":"Authorization behaviour","ref":"K8s.Conn.Auth.html"},{"type":"callback","title":"K8s.Conn.Auth.create/2","doc":"Creates a struct holding the information to authenticate against the API server. Arguments auth_map - A map representing the .users[].user part from a kubeconfig. base_path - The path to the folder holding the kubeconfig file. Result The struct returned by this function MUST implement the K8s.Conn.RequestOptions protocol. Return :skip to signal to K8s.Conn to skip a provider that would not authenticate the current connection. Examples See the various modules implementing this behaviour for examples.","ref":"K8s.Conn.Auth.html#c:create/2"},{"type":"module","title":"K8s.Conn.Auth.AuthProvider","doc":"auth-provider authentication support","ref":"K8s.Conn.Auth.AuthProvider.html"},{"type":"function","title":"K8s.Conn.Auth.AuthProvider.generate_token/1","doc":"&quot;Generate&quot; a token using the auth-provider config in kube config.","ref":"K8s.Conn.Auth.AuthProvider.html#generate_token/1"},{"type":"type","title":"K8s.Conn.Auth.AuthProvider.t/0","doc":"","ref":"K8s.Conn.Auth.AuthProvider.html#t:t/0"},{"type":"module","title":"K8s.Conn.Auth.Azure","doc":"auth-provider for azure","ref":"K8s.Conn.Auth.Azure.html"},{"type":"function","title":"K8s.Conn.Auth.Azure.refresh_token/4","doc":"","ref":"K8s.Conn.Auth.Azure.html#refresh_token/4"},{"type":"type","title":"K8s.Conn.Auth.Azure.t/0","doc":"","ref":"K8s.Conn.Auth.Azure.html#t:t/0"},{"type":"module","title":"K8s.Conn.Auth.BasicAuth","doc":"basic auth cluster authentication","ref":"K8s.Conn.Auth.BasicAuth.html"},{"type":"type","title":"K8s.Conn.Auth.BasicAuth.t/0","doc":"","ref":"K8s.Conn.Auth.BasicAuth.html#t:t/0"},{"type":"module","title":"K8s.Conn.Auth.Certificate","doc":"Certificate based cluster authentication.","ref":"K8s.Conn.Auth.Certificate.html"},{"type":"type","title":"K8s.Conn.Auth.Certificate.t/0","doc":"","ref":"K8s.Conn.Auth.Certificate.html#t:t/0"},{"type":"module","title":"K8s.Conn.Auth.DigitalOcean","doc":"Cluster authentication for kube configs created by doctl, the DigitalOcean CLI","ref":"K8s.Conn.Auth.DigitalOcean.html"},{"type":"module","title":"K8s.Conn.Auth.Exec","doc":"Cluster authentication for kube configs using an exec section. Useful for Kubernetes clusters running on AWS which use IAM authentication (eg. the aws-iam-authenticator binary). An applicable kube config may look something like this: # ... users : - name : staging - user user : exec : # API version to use when decoding the ExecCredentials resource. Required. apiVersion : client . authentication . k8s . io / v1alpha1 # Command to execute. Required. command : aws - iam - authenticator # Arguments to pass when executing the plugin. Optional. args : - token - - i - staging # Environment variables to set when executing the plugin. Optional. env : - name : &quot;FOO&quot; value : &quot;bar&quot;","ref":"K8s.Conn.Auth.Exec.html"},{"type":"function","title":"K8s.Conn.Auth.Exec.generate_token/1","doc":"&quot;Generate&quot; a token using the exec config in kube config.","ref":"K8s.Conn.Auth.Exec.html#generate_token/1"},{"type":"type","title":"K8s.Conn.Auth.Exec.t/0","doc":"","ref":"K8s.Conn.Auth.Exec.html#t:t/0"},{"type":"module","title":"K8s.Conn.Auth.Token","doc":"Token based cluster authentication","ref":"K8s.Conn.Auth.Token.html"},{"type":"type","title":"K8s.Conn.Auth.Token.t/0","doc":"","ref":"K8s.Conn.Auth.Token.html#t:t/0"},{"type":"module","title":"K8s.Conn.PKI","doc":"Retrieves information from certificates","ref":"K8s.Conn.PKI.html"},{"type":"function","title":"K8s.Conn.PKI.cert_from_base64/1","doc":"Decodes the certificate from a base64 encoded string","ref":"K8s.Conn.PKI.html#cert_from_base64/1"},{"type":"function","title":"K8s.Conn.PKI.cert_from_map/2","doc":"Reads the certificate from PEM file or base64 encoding","ref":"K8s.Conn.PKI.html#cert_from_map/2"},{"type":"function","title":"K8s.Conn.PKI.cert_from_pem/1","doc":"Reads the certificate from a PEM file","ref":"K8s.Conn.PKI.html#cert_from_pem/1"},{"type":"function","title":"K8s.Conn.PKI.private_key_from_base64/1","doc":"Decodes private key from a base64 encoded string","ref":"K8s.Conn.PKI.html#private_key_from_base64/1"},{"type":"function","title":"K8s.Conn.PKI.private_key_from_pem/1","doc":"Reads private key from a PEM file","ref":"K8s.Conn.PKI.html#private_key_from_pem/1"},{"type":"type","title":"K8s.Conn.PKI.private_key_data_t/0","doc":"","ref":"K8s.Conn.PKI.html#t:private_key_data_t/0"},{"type":"protocol","title":"K8s.Conn.RequestOptions","doc":"Encapsulates HTTP request options for an authentication provider.","ref":"K8s.Conn.RequestOptions.html"},{"type":"function","title":"K8s.Conn.RequestOptions.generate/1","doc":"","ref":"K8s.Conn.RequestOptions.html#generate/1"},{"type":"type","title":"K8s.Conn.RequestOptions.generate_t/0","doc":"generate/1 response type","ref":"K8s.Conn.RequestOptions.html#t:generate_t/0"},{"type":"type","title":"K8s.Conn.RequestOptions.t/0","doc":"HTTP Request options","ref":"K8s.Conn.RequestOptions.html#t:t/0"},{"type":"module","title":"K8s.Discovery","doc":"Kubernetes API Discovery","ref":"K8s.Discovery.html"},{"type":"function","title":"K8s.Discovery.default_driver/0","doc":"","ref":"K8s.Discovery.html#default_driver/0"},{"type":"function","title":"K8s.Discovery.default_opts/0","doc":"","ref":"K8s.Discovery.html#default_opts/0"},{"type":"function","title":"K8s.Discovery.resources/3","doc":"Kubernetes API Resources supported by the cluster.","ref":"K8s.Discovery.html#resources/3"},{"type":"function","title":"K8s.Discovery.url_for/2","doc":"Discovery the URL for a K8s.Conn and K8s.Operation Examples iex&gt; { :ok , conn } = K8s.Conn . from_file ( &quot;./test/support/kube-config.yaml&quot; ) ...&gt; op = K8s.Operation . build ( :get , &quot;apps/v1&quot; , :deployments , [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] ) ...&gt; K8s.Discovery . url_for ( conn , op ) { :ok , &quot;https://localhost:6443/apis/apps/v1/namespaces/default/deployments/nginx&quot; }","ref":"K8s.Discovery.html#url_for/2"},{"type":"function","title":"K8s.Discovery.versions/2","doc":"Kubernetes API Versions supported by the cluster.","ref":"K8s.Discovery.html#versions/2"},{"type":"behaviour","title":"K8s.Discovery.Driver","doc":"Driver behaviour for K8s.Discovery","ref":"K8s.Discovery.Driver.html"},{"type":"callback","title":"K8s.Discovery.Driver.resources/2","doc":"List of Kubernetes APIResourceList s Examples iex&gt; { :ok , conn } = K8s.Conn . from_file ( &quot;test/support/kube-config.yaml&quot; ) ...&gt; K8s.Discovery.Driver.HTTP . resources ( &quot;autoscaling/v1&quot; , conn ) { :ok , [ %{ &quot;kind&quot; =&gt; &quot;DaemonSet&quot; , &quot;name&quot; =&gt; &quot;daemonsets&quot; } , %{ &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;name&quot; =&gt; &quot;deployments&quot; } , %{ &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;name&quot; =&gt; &quot;deployments/status&quot; } ] }","ref":"K8s.Discovery.Driver.html#c:resources/2"},{"type":"callback","title":"K8s.Discovery.Driver.resources/3","doc":"","ref":"K8s.Discovery.Driver.html#c:resources/3"},{"type":"callback","title":"K8s.Discovery.Driver.versions/1","doc":"List of Kubernetes apiVersion s Examples iex&gt; { :ok , conn } = K8s.Conn . from_file ( &quot;test/support/kube-config.yaml&quot; ) ...&gt; K8s.Discovery.Driver.HTTP . api ( conn ) { :ok , [ &quot;v1&quot; ] }","ref":"K8s.Discovery.Driver.html#c:versions/1"},{"type":"callback","title":"K8s.Discovery.Driver.versions/2","doc":"","ref":"K8s.Discovery.Driver.html#c:versions/2"},{"type":"type","title":"K8s.Discovery.Driver.driver_error_t/0","doc":"Errors returned by adapters should return an error tuple with an atom() describing the error or alternatively an &quot;error&quot; struct with more details. Examples { :error , :file_not_found } { :error , % K8s.Discovery.Driver.MyDriver.FileNotFoundError { config : &quot;path-to-file&quot; } }","ref":"K8s.Discovery.Driver.html#t:driver_error_t/0"},{"type":"module","title":"K8s.Discovery.Driver.File","doc":"File Driver for Kubernetes API discovery. This module allows API versions and Resources accessible by the k8s to be defined rather than discovered. This module is primarily used for testing, but can be used if you wish to hard code supported API versions and resources. See ./test/support/discovery/example.json for an example. Examples &quot;Discovering&quot; hard coded resources. iex&gt; K8s.Discovery.Driver.File . resources ( &quot;apps/v1&quot; , % K8s.Conn { } , config : &quot;./test/support/discovery/example.json&quot; ) [ %{ &quot;kind&quot; =&gt; &quot;DaemonSet&quot; , &quot;name&quot; =&gt; &quot;daemonsets&quot; } , %{ &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;name&quot; =&gt; &quot;deployments&quot; } , %{ &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;name&quot; =&gt; &quot;deployments/status&quot; } ] &quot;Discovering&quot; hard coded versions. iex&gt; K8s.Discovery.Driver.File . versions ( % K8s.Conn { } , config : &quot;./test/support/discovery/example.json&quot; ) [ &quot;v1&quot; , &quot;apps/v1&quot; ]","ref":"K8s.Discovery.Driver.File.html"},{"type":"module","title":"K8s.Discovery.Driver.HTTP","doc":"HTTP Driver for Kubernetes API discovery","ref":"K8s.Discovery.Driver.HTTP.html"},{"type":"module","title":"K8s.Discovery.ResourceFinder","doc":"Kubernetes API Groups","ref":"K8s.Discovery.ResourceFinder.html"},{"type":"function","title":"K8s.Discovery.ResourceFinder.find_resource/3","doc":"Finds a resource definition by api version and (name or kind).","ref":"K8s.Discovery.ResourceFinder.html#find_resource/3"},{"type":"function","title":"K8s.Discovery.ResourceFinder.resource_name_for_kind/3","doc":"Get the REST resource name for a kubernetes Kind . Since K8s.Operation is abstracted away from a specific cluster, when working with kubernetes resource Map s and specifying &quot;kind&quot; the K8s.Operation.Path module isn't able to determine the correct path. (It will generate things like /api/v1/Pod instead of api/v1/pods). Also accepts REST resource name in the event they are provided, as it may be known in the event of subresources.","ref":"K8s.Discovery.ResourceFinder.html#resource_name_for_kind/3"},{"type":"type","title":"K8s.Discovery.ResourceFinder.error_t/0","doc":"","ref":"K8s.Discovery.ResourceFinder.html#t:error_t/0"},{"type":"module","title":"K8s.Middleware","doc":"Interface for interacting with cluster middleware While middlewares are applied to K8s.Middleware.Request s they are registerd by a cluster name which is an atom. This allows multiple connections to be used (different credentials) with the same middleware stack. Any cluster name that has not been initialized, will automatically have the default stack applied. Examples Using default middleware iex&gt; conn = % K8s.Conn { } ...&gt; req = % K8s.Middlware.Request { } ...&gt; K8s.Middleware . run ( req ) Adding middlware to a cluster iex&gt; conn = % K8s.Conn { cluster_name : &quot;foo&quot; } ...&gt; K8s.Middleware . add ( &quot;foo&quot; , :request , MyMiddlewareModule ) ...&gt; req = % K8s.Middlware.Request { } ...&gt; K8s.Middleware . run ( req ) Setting/Replacing middleware on a cluster iex&gt; conn = % K8s.Conn { cluster_name : &quot;foo&quot; } ...&gt; K8s.Middleware . set ( &quot;foo&quot; , :request , [ MyMiddlewareModule , OtherModule ] ) ...&gt; req = % K8s.Middlware.Request { } ...&gt; K8s.Middleware . run ( req )","ref":"K8s.Middleware.html"},{"type":"function","title":"K8s.Middleware.run/2","doc":"","ref":"K8s.Middleware.html#run/2"},{"type":"module","title":"K8s.Middleware.Error","doc":"Encapsulates middleware process errors","ref":"K8s.Middleware.Error.html"},{"type":"type","title":"K8s.Middleware.Error.t/0","doc":"Middleware processing error middleware middleware module that caused the error request K8s.Middleware.Request error actual error, can be any() type","ref":"K8s.Middleware.Error.html#t:t/0"},{"type":"behaviour","title":"K8s.Middleware.Request","doc":"HTTP Request middleware","ref":"K8s.Middleware.Request.html"},{"type":"callback","title":"K8s.Middleware.Request.call/1","doc":"Request middleware callback","ref":"K8s.Middleware.Request.html#c:call/1"},{"type":"type","title":"K8s.Middleware.Request.t/0","doc":"Middleware Request type","ref":"K8s.Middleware.Request.html#t:t/0"},{"type":"module","title":"K8s.Middleware.Request.EncodeBody","doc":"Naive JSON body encoder. Encodes JSON payloads when given an modifiying HTTP verb, otherwise returns an empty string.","ref":"K8s.Middleware.Request.EncodeBody.html"},{"type":"module","title":"K8s.Middleware.Request.Initialize","doc":"Initializes a request with connection details (header and HTTPoison opts) from K8s.Conn.RequestOptions","ref":"K8s.Middleware.Request.Initialize.html"},{"type":"module","title":"K8s.Middleware.Stack","doc":"K8s.Middlware stacks to apply to a K8s.Conn","ref":"K8s.Middleware.Stack.html"},{"type":"function","title":"K8s.Middleware.Stack.default/0","doc":"The default middleware stack","ref":"K8s.Middleware.Stack.html#default/0"},{"type":"type","title":"K8s.Middleware.Stack.t/0","doc":"","ref":"K8s.Middleware.Stack.html#t:t/0"},{"type":"module","title":"K8s.Operation","doc":"Encapsulates Kubernetes REST API operations.","ref":"K8s.Operation.html"},{"type":"function","title":"K8s.Operation.build/3","doc":"Builds an Operation given a verb and a k8s resource. Examples iex&gt; deploy = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;name&quot; =&gt; &quot;nginx&quot; } } ...&gt; K8s.Operation . build ( :update , deploy ) % K8s.Operation { method : :put , verb : :update , data : %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;name&quot; =&gt; &quot;nginx&quot; } } , path_params : [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , api_version : &quot;apps/v1&quot; , name : &quot;Deployment&quot; }","ref":"K8s.Operation.html#build/3"},{"type":"function","title":"K8s.Operation.build/6","doc":"Builds an Operation given an verb and a k8s resource info. Note: The name here may be a Kind and not a REST resource name in the event that the operation was built using a map. Use K8s.Discovery.ResourceFinder.resource_name_for_kind/3 to get the correct REST resource name, given a kind . Examples Building a GET deployment operation: iex&gt; K8s.Operation . build ( :get , &quot;apps/v1&quot; , :deployment , [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] ) % K8s.Operation { method : :get , verb : :get , data : nil , path_params : [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , api_version : &quot;apps/v1&quot; , name : :deployment } Building a GET deployments/status operation: iex&gt; K8s.Operation . build ( :get , &quot;apps/v1&quot; , &quot;deployments/status&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] ) % K8s.Operation { method : :get , verb : :get , data : nil , path_params : [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , api_version : &quot;apps/v1&quot; , name : &quot;deployments/status&quot; }","ref":"K8s.Operation.html#build/6"},{"type":"function","title":"K8s.Operation.get_label_selector/1","doc":"See K8s.Operation.get_selector/1 .","ref":"K8s.Operation.html#get_label_selector/1"},{"type":"function","title":"K8s.Operation.get_query_param/2","doc":"Get a query param of an operation Examples Using a keyword list of params: iex&gt; operation = % K8s.Operation { query_params : [ foo : &quot;bar&quot; ] } ...&gt; K8s.Operation . get_query_param ( operation , :foo ) &quot;bar&quot;","ref":"K8s.Operation.html#get_query_param/2"},{"type":"function","title":"K8s.Operation.get_selector/1","doc":"Gets a K8s.Selector on the operation. Examples iex&gt; operation = % K8s.Operation { query_params : [ labelSelector : K8s.Selector . label ( { &quot;component&quot; , &quot;redis&quot; } ) ] } ...&gt; K8s.Operation . get_selector ( operation ) % K8s.Selector { match_expressions : [ ] , match_labels : %{ &quot;component&quot; =&gt; { &quot;=&quot; , &quot;redis&quot; } } }","ref":"K8s.Operation.html#get_selector/1"},{"type":"function","title":"K8s.Operation.put_conn/2","doc":"Set the connection object on the operation Examples iex&gt; operation = % K8s.Operation { query_params : [ foo : &quot;bar&quot; ] } ...&gt; conn = % K8s.Conn { } ...&gt; operation = K8s.Operation . put_conn ( operation , conn ) ...&gt; match? ( % K8s.Operation { conn : % K8s.Conn { } } , operation ) true","ref":"K8s.Operation.html#put_conn/2"},{"type":"function","title":"K8s.Operation.put_label_selector/2","doc":"See K8s.Operation.put_selector/2 .","ref":"K8s.Operation.html#put_label_selector/2"},{"type":"function","title":"K8s.Operation.put_query_param/2","doc":"","ref":"K8s.Operation.html#put_query_param/2"},{"type":"function","title":"K8s.Operation.put_query_param/3","doc":"Add a query param to an operation Examples Using a keyword list of params: iex&gt; operation = % K8s.Operation { } ...&gt; K8s.Operation . put_query_param ( operation , :foo , &quot;bar&quot; ) % K8s.Operation { query_params : [ foo : &quot;bar&quot; ] }","ref":"K8s.Operation.html#put_query_param/3"},{"type":"function","title":"K8s.Operation.put_selector/2","doc":"Puts a K8s.Selector on the operation. Examples iex&gt; operation = % K8s.Operation { } ...&gt; selector = K8s.Selector . label ( { &quot;component&quot; , &quot;redis&quot; } ) ...&gt; K8s.Operation . put_selector ( operation , selector ) % K8s.Operation { query_params : [ labelSelector : % K8s.Selector { match_expressions : [ ] , match_labels : %{ &quot;component&quot; =&gt; { &quot;=&quot; , &quot;redis&quot; } } } ] }","ref":"K8s.Operation.html#put_selector/2"},{"type":"function","title":"K8s.Operation.to_path/1","doc":"Converts a K8s.Operation into a URL path.","ref":"K8s.Operation.html#to_path/1"},{"type":"type","title":"K8s.Operation.name_t/0","doc":"K8s.Operation name. May be an atom, string, or tuple of {resource, subresource} .","ref":"K8s.Operation.html#t:name_t/0"},{"type":"type","title":"K8s.Operation.patch_type/0","doc":"Acceptable patch types","ref":"K8s.Operation.html#t:patch_type/0"},{"type":"type","title":"K8s.Operation.t/0","doc":"api_version - API groupVersion , AKA apiVersion name - The name of the REST operation (Kubernets kind/resource/subresource). This is not always the same as the kind key in the data field. e.g: deployments when POSTing, GETting a deployment. data - HTTP request body to submit when applicable. (POST, PUT, PATCH, etc) method - HTTP Method verb - Kubernetes REST API verb ( deletecollection , update , create , watch , etc) path_params - Parameters to interpolate into the Kubernetes REST URL query_params - Query parameters. Merged w/ params provided to any K8s.Client.Runner . K8s.Client.Runner options win. header_params - Header parameters. name would be deployments in the case of a deployment, but may be deployments/status or deployments/scale for Status and Scale subresources. name and data field examples The following example would update the nginx deployment's Scale . Note the deployments/scale operation will have a Scale data payload: % K8s.Operation { method : :put , verb : :update , api_version : &quot;v1&quot; , # api version of the &quot;Scale&quot; kind name : &quot;deployments/scale&quot; , data : %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Scale&quot; } , # `data` is of kind &quot;Scale&quot; path_params : [ name : &quot;nginx&quot; , namespace : &quot;default&quot; ] , header_params : [ &quot;Content-Type&quot; : &quot;application/json&quot; ] } The following example would update the nginx deployment's Status . Note the deployments/status operation will have a Deployment data payload: % K8s.Operation { method : :put , verb : :update , api_version : &quot;apps/v1&quot; , # api version of the &quot;Deployment&quot; kind name : &quot;deployments/status&quot; , data : %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; } , # `data` is of kind &quot;Deployment&quot; path_params : [ name : &quot;nginx&quot; , namespace : &quot;default&quot; ] , header_params : [ &quot;Content-Type&quot; : &quot;application/json&quot; ] }","ref":"K8s.Operation.html#t:t/0"},{"type":"module","title":"K8s.Operation.Path","doc":"Generates Kubernetes REST API Paths","ref":"K8s.Operation.Path.html"},{"type":"function","title":"K8s.Operation.Path.build/1","doc":"Generates the API path for a K8s.Operation . Examples Generate a path for a cluster scoped resource: iex&gt; resource = K8s.Resource . build ( &quot;apps/v1&quot; , &quot;CertificateSigningRequest&quot; , &quot;foo&quot; ) ...&gt; operation = % K8s.Operation { ...&gt; method : :put , ...&gt; verb : :update , ...&gt; data : resource , ...&gt; path_params : [ name : &quot;foo&quot; ] , ...&gt; api_version : &quot;apps/v1&quot; , ...&gt; name : &quot;certificatesigningrequests&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/apis/apps/v1/certificatesigningrequests/foo&quot; } iex&gt; resource = K8s.Resource . build ( &quot;apps/v1&quot; , &quot;CertificateSigningRequest&quot; , &quot;foo&quot; ) ...&gt; operation = % K8s.Operation { ...&gt; method : :put , ...&gt; verb : :update , ...&gt; data : resource , ...&gt; path_params : [ name : &quot;foo&quot; , namespace : nil ] , ...&gt; api_version : &quot;apps/v1&quot; , ...&gt; name : &quot;certificatesigningrequests&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/apis/apps/v1/certificatesigningrequests/foo&quot; } Generate a path for a namespace scoped resource: iex&gt; resource = K8s.Resource . build ( &quot;v1&quot; , &quot;Pod&quot; , &quot;default&quot; , &quot;foo&quot; ) ...&gt; operation = % K8s.Operation { ...&gt; method : :put , ...&gt; verb : :update , ...&gt; data : resource , ...&gt; path_params : [ namespace : &quot;default&quot; , name : &quot;foo&quot; ] , ...&gt; api_version : &quot;v1&quot; , ...&gt; name : &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/api/v1/namespaces/default/pods/foo&quot; } Generate a path for a namespace scoped resource on the collection: (ie create, list) iex&gt; resource = K8s.Resource . build ( &quot;v1&quot; , &quot;Pod&quot; , &quot;default&quot; , &quot;foo&quot; ) ...&gt; operation = % K8s.Operation { ...&gt; method : :post , ...&gt; verb : :create , ...&gt; data : resource , ...&gt; path_params : [ namespace : &quot;default&quot; , name : &quot;foo&quot; ] , ...&gt; api_version : &quot;v1&quot; , ...&gt; name : &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/api/v1/namespaces/default/pods&quot; } Generating a listing path for a namespace: iex&gt; operation = % K8s.Operation { ...&gt; method : :get , ...&gt; verb : :list , ...&gt; data : nil , ...&gt; path_params : [ namespace : &quot;default&quot; ] , ...&gt; api_version : &quot;v1&quot; , ...&gt; name : &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/api/v1/namespaces/default/pods&quot; } Generating a listing path for a all namespaces: iex&gt; operation = % K8s.Operation { ...&gt; method : :get , ...&gt; verb : :list_all_namespaces , ...&gt; data : nil , ...&gt; path_params : [ namespace : &quot;default&quot; ] , ...&gt; api_version : &quot;v1&quot; , ...&gt; name : &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/api/v1/pods&quot; } Generating a listing path for a watching all namespaces: iex&gt; operation = % K8s.Operation { ...&gt; method : :get , ...&gt; verb : :watch_all_namespaces , ...&gt; data : nil , ...&gt; path_params : [ namespace : &quot;default&quot; ] , ...&gt; api_version : &quot;v1&quot; , ...&gt; name : &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/api/v1/pods&quot; } Generating a path for a subresource: iex&gt; operation = % K8s.Operation { ...&gt; method : :get , ...&gt; verb : :get , ...&gt; data : nil , ...&gt; path_params : [ namespace : &quot;default&quot; , name : &quot;foo&quot; ] , ...&gt; api_version : &quot;v1&quot; , ...&gt; name : &quot;pods/status&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/api/v1/namespaces/default/pods/foo/status&quot; } Deleting a collection: iex&gt; operation = % K8s.Operation { ...&gt; method : :delete , ...&gt; verb : :deletecollection , ...&gt; data : nil , ...&gt; path_params : [ namespace : &quot;default&quot; ] , ...&gt; api_version : &quot;v1&quot; , ...&gt; name : &quot;pods&quot; ...&gt; } ...&gt; K8s.Operation.Path . build ( operation ) { :ok , &quot;/api/v1/namespaces/default/pods&quot; }","ref":"K8s.Operation.Path.html#build/1"},{"type":"function","title":"K8s.Operation.Path.find_params/1","doc":"Find valid path params in a URL path. Examples iex&gt; K8s.Operation.Path . find_params ( &quot;/foo/{name}&quot; ) [ :name ] iex&gt; K8s.Operation.Path . find_params ( &quot;/foo/{namespace}/bar/{name}&quot; ) [ :namespace , :name ] iex&gt; K8s.Operation.Path . find_params ( &quot;/foo/bar&quot; ) [ ]","ref":"K8s.Operation.Path.html#find_params/1"},{"type":"function","title":"K8s.Operation.Path.replace_path_vars/2","doc":"Replaces path variables with options. Examples iex&gt; K8s.Operation.Path . replace_path_vars ( &quot;/foo/{name}&quot; , name : &quot;bar&quot; ) &quot;/foo/bar&quot;","ref":"K8s.Operation.Path.html#replace_path_vars/2"},{"type":"module","title":"K8s.Resource","doc":"Kubernetes manifest attribute helpers","ref":"K8s.Resource.html"},{"type":"function","title":"K8s.Resource.all_from_file/2","doc":"Create a list of resource Map s from a YAML file containing a YAML stream. Examples iex&gt; opts = [ namespace : &quot;default&quot; , name : &quot;nginx&quot; , image : &quot;nginx:nginx:1.7.9&quot; ] ...&gt; K8s.Resource . all_from_file ( &quot;test/support/helm-chart.yaml&quot; , opts ) { :ok , [ %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Namespace&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;default&quot; } } , %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } , &quot;name&quot; =&gt; &quot;nginx-deployment&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } , &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3 , &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot; , &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;ports&quot; =&gt; [ %{ &quot;containerPort&quot; =&gt; 80 } ] } ] } } } } ] }","ref":"K8s.Resource.html#all_from_file/2"},{"type":"function","title":"K8s.Resource.all_from_file!/2","doc":"Create a list of resource Map s from a YAML file containing a YAML stream. Raises File.Error when the file does not exist. Examples iex&gt; opts = [ namespace : &quot;default&quot; , name : &quot;nginx&quot; , image : &quot;nginx:nginx:1.7.9&quot; ] ...&gt; K8s.Resource . all_from_file! ( &quot;test/support/helm-chart.yaml&quot; , opts ) [ %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Namespace&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;default&quot; } } , %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } , &quot;name&quot; =&gt; &quot;nginx-deployment&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } , &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3 , &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot; , &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;ports&quot; =&gt; [ %{ &quot;containerPort&quot; =&gt; 80 } ] } ] } } } } ]","ref":"K8s.Resource.html#all_from_file!/2"},{"type":"function","title":"K8s.Resource.annotation/2","doc":"See K8s.Resource.FieldAccessors.annotation/2 .","ref":"K8s.Resource.html#annotation/2"},{"type":"function","title":"K8s.Resource.annotations/1","doc":"See K8s.Resource.FieldAccessors.annotations/1 .","ref":"K8s.Resource.html#annotations/1"},{"type":"function","title":"K8s.Resource.api_version/1","doc":"See K8s.Resource.FieldAccessors.api_version/1 .","ref":"K8s.Resource.html#api_version/1"},{"type":"function","title":"K8s.Resource.build/2","doc":"Helper for building a kubernetes' resource Map Examples iex&gt; K8s.Resource . build ( &quot;v1&quot; , &quot;Pod&quot; ) %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Pod&quot; , &quot;metadata&quot; =&gt; %{ } } iex&gt; K8s.Resource . build ( &quot;v1&quot; , &quot;Namespace&quot; , &quot;foo&quot; ) %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Namespace&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;foo&quot; } } iex&gt; K8s.Resource . build ( &quot;v1&quot; , &quot;Pod&quot; , &quot;default&quot; , &quot;foo&quot; ) %{ &quot;apiVersion&quot; =&gt; &quot;v1&quot; , &quot;kind&quot; =&gt; &quot;Pod&quot; , &quot;metadata&quot; =&gt; %{ &quot;namespace&quot; =&gt; &quot;default&quot; , &quot;name&quot; =&gt; &quot;foo&quot; } }","ref":"K8s.Resource.html#build/2"},{"type":"function","title":"K8s.Resource.build/3","doc":"","ref":"K8s.Resource.html#build/3"},{"type":"function","title":"K8s.Resource.build/4","doc":"","ref":"K8s.Resource.html#build/4"},{"type":"function","title":"K8s.Resource.build/5","doc":"","ref":"K8s.Resource.html#build/5"},{"type":"function","title":"K8s.Resource.cpu/1","doc":"See K8s.Resource.Utilization.cpu/1 .","ref":"K8s.Resource.html#cpu/1"},{"type":"function","title":"K8s.Resource.from_file/2","doc":"Create a resource Map from a YAML file. Examples iex&gt; opts = [ namespace : &quot;default&quot; , name : &quot;nginx&quot; , image : &quot;nginx:nginx:1.7.9&quot; ] ...&gt; K8s.Resource . from_file ( &quot;test/support/deployment.yaml&quot; , opts ) { :ok , %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } , &quot;name&quot; =&gt; &quot;nginx-deployment&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } , &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3 , &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot; , &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;ports&quot; =&gt; [ %{ &quot;containerPort&quot; =&gt; 80 } ] } ] } } } } }","ref":"K8s.Resource.html#from_file/2"},{"type":"function","title":"K8s.Resource.from_file!/2","doc":"Create a resource Map from a YAML file. Raises File.Error when the file does not exist. Examples iex&gt; opts = [ namespace : &quot;default&quot; , name : &quot;nginx&quot; , image : &quot;nginx:nginx:1.7.9&quot; ] ...&gt; K8s.Resource . from_file! ( &quot;test/support/deployment.yaml&quot; , opts ) %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } , &quot;name&quot; =&gt; &quot;nginx-deployment&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } , &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3 , &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:nginx:1.7.9&quot; , &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;ports&quot; =&gt; [ %{ &quot;containerPort&quot; =&gt; 80 } ] } ] } } } }","ref":"K8s.Resource.html#from_file!/2"},{"type":"function","title":"K8s.Resource.has_annotation?/2","doc":"See K8s.Resource.FieldAccessors.has_annotation?/2 .","ref":"K8s.Resource.html#has_annotation?/2"},{"type":"function","title":"K8s.Resource.has_label?/2","doc":"See K8s.Resource.FieldAccessors.has_label?/2 .","ref":"K8s.Resource.html#has_label?/2"},{"type":"function","title":"K8s.Resource.kind/1","doc":"See K8s.Resource.FieldAccessors.kind/1 .","ref":"K8s.Resource.html#kind/1"},{"type":"function","title":"K8s.Resource.label/2","doc":"See K8s.Resource.FieldAccessors.label/2 .","ref":"K8s.Resource.html#label/2"},{"type":"function","title":"K8s.Resource.labels/1","doc":"See K8s.Resource.FieldAccessors.labels/1 .","ref":"K8s.Resource.html#labels/1"},{"type":"function","title":"K8s.Resource.memory/1","doc":"See K8s.Resource.Utilization.memory/1 .","ref":"K8s.Resource.html#memory/1"},{"type":"function","title":"K8s.Resource.metadata/1","doc":"See K8s.Resource.FieldAccessors.metadata/1 .","ref":"K8s.Resource.html#metadata/1"},{"type":"function","title":"K8s.Resource.name/1","doc":"See K8s.Resource.FieldAccessors.name/1 .","ref":"K8s.Resource.html#name/1"},{"type":"function","title":"K8s.Resource.namespace/1","doc":"See K8s.Resource.FieldAccessors.namespace/1 .","ref":"K8s.Resource.html#namespace/1"},{"type":"type","title":"K8s.Resource.yaml_elixir_error_t/0","doc":"","ref":"K8s.Resource.html#t:yaml_elixir_error_t/0"},{"type":"module","title":"K8s.Resource.FieldAccessors","doc":"Helper functions for accessing common fields","ref":"K8s.Resource.FieldAccessors.html"},{"type":"function","title":"K8s.Resource.FieldAccessors.annotation/2","doc":"Returns the value of a k8s resource's annotation. Examples iex&gt; K8s.Resource.FieldAccessors . annotation ( %{ &quot;metadata&quot; =&gt; %{ &quot;annotations&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;test&quot; } } } , &quot;env&quot; ) &quot;test&quot;","ref":"K8s.Resource.FieldAccessors.html#annotation/2"},{"type":"function","title":"K8s.Resource.FieldAccessors.annotations/1","doc":"Returns the annotations of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors . annotations ( %{ &quot;metadata&quot; =&gt; %{ &quot;annotations&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;test&quot; } } } ) %{ &quot;env&quot; =&gt; &quot;test&quot; }","ref":"K8s.Resource.FieldAccessors.html#annotations/1"},{"type":"function","title":"K8s.Resource.FieldAccessors.api_version/1","doc":"Returns the apiVersion of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors . api_version ( %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; } ) &quot;apps/v1&quot;","ref":"K8s.Resource.FieldAccessors.html#api_version/1"},{"type":"function","title":"K8s.Resource.FieldAccessors.has_annotation?/2","doc":"Check if an annotation is present. Examples iex&gt; K8s.Resource.FieldAccessors . has_annotation? ( %{ &quot;metadata&quot; =&gt; %{ &quot;annotations&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;test&quot; } } } , &quot;env&quot; ) true iex&gt; K8s.Resource.FieldAccessors . has_annotation? ( %{ &quot;metadata&quot; =&gt; %{ &quot;annotations&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;test&quot; } } } , &quot;foo&quot; ) false","ref":"K8s.Resource.FieldAccessors.html#has_annotation?/2"},{"type":"function","title":"K8s.Resource.FieldAccessors.has_label?/2","doc":"Check if a label is present. Examples iex&gt; K8s.Resource.FieldAccessors . has_label? ( %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;test&quot; } } } , &quot;env&quot; ) true iex&gt; K8s.Resource.FieldAccessors . has_label? ( %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;test&quot; } } } , &quot;foo&quot; ) false","ref":"K8s.Resource.FieldAccessors.html#has_label?/2"},{"type":"function","title":"K8s.Resource.FieldAccessors.kind/1","doc":"Returns the kind of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors . kind ( %{ &quot;kind&quot; =&gt; &quot;Deployment&quot; } ) &quot;Deployment&quot;","ref":"K8s.Resource.FieldAccessors.html#kind/1"},{"type":"function","title":"K8s.Resource.FieldAccessors.label/2","doc":"Returns the value of a k8s resource's label. Examples iex&gt; K8s.Resource.FieldAccessors . label ( %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;test&quot; } } } , &quot;env&quot; ) &quot;test&quot;","ref":"K8s.Resource.FieldAccessors.html#label/2"},{"type":"function","title":"K8s.Resource.FieldAccessors.labels/1","doc":"Returns the labels of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors . labels ( %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;test&quot; } } } ) %{ &quot;env&quot; =&gt; &quot;test&quot; }","ref":"K8s.Resource.FieldAccessors.html#labels/1"},{"type":"function","title":"K8s.Resource.FieldAccessors.metadata/1","doc":"Returns the metadata of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors . metadata ( %{ &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;foo&quot; } } ) %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;foo&quot; }","ref":"K8s.Resource.FieldAccessors.html#metadata/1"},{"type":"function","title":"K8s.Resource.FieldAccessors.name/1","doc":"Returns the name of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors . name ( %{ &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;foo&quot; } } ) &quot;nginx&quot;","ref":"K8s.Resource.FieldAccessors.html#name/1"},{"type":"function","title":"K8s.Resource.FieldAccessors.namespace/1","doc":"Returns the namespace of k8s resource. Examples iex&gt; K8s.Resource.FieldAccessors . namespace ( %{ &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;namespace&quot; =&gt; &quot;foo&quot; } } ) &quot;foo&quot;","ref":"K8s.Resource.FieldAccessors.html#namespace/1"},{"type":"module","title":"K8s.Resource.NamedList","doc":"Provides an accessor to a list of maps whereas each element in the list has a key named &quot;name&quot;. The name should be unique within the list and therefore defining the element.","ref":"K8s.Resource.NamedList.html"},{"type":"function","title":"K8s.Resource.NamedList.access/1","doc":"Provides an accessor to a list of maps whereas each element in the list has a key named &quot;name&quot;. If no such element exists within the given list, get_in() will return nil while updating will create an empty element with the given name. Examples iex&gt; get_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}], [K8s.Resource.NamedList.access(&quot;key2&quot;), &quot;value&quot;]) &quot;value2&quot; iex&gt; get_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}], [K8s.Resource.NamedList.access(&quot;key2&quot;)]) %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;} iex&gt; get_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access(&quot;missing-key&quot;), &quot;value&quot;]) nil iex&gt; get_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access(&quot;missing-key&quot;)]) nil iex&gt; put_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}], [K8s.Resource.NamedList.access(&quot;key1&quot;), &quot;value&quot;], &quot;value_new&quot;) [%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value_new&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}] iex&gt; put_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access(&quot;missing-key&quot;), &quot;value&quot;], &quot;value_new&quot;) [%{&quot;name&quot; =&gt; &quot;missing-key&quot;, &quot;value&quot; =&gt; &quot;value_new&quot;}, %{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}] iex&gt; pop_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}], [K8s.Resource.NamedList.access(&quot;key1&quot;), &quot;value&quot;]) {&quot;value1&quot;, [%{&quot;name&quot; =&gt; &quot;key1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}]} iex&gt; pop_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access(&quot;missing-key&quot;), &quot;value&quot;]) {nil, [%{&quot;name&quot; =&gt; &quot;missing-key&quot;}, %{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}]} iex&gt; pop_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access(&quot;missing-key&quot;)]) {%{&quot;name&quot; =&gt; &quot;missing-key&quot;}, [%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}]}","ref":"K8s.Resource.NamedList.html#access/1"},{"type":"function","title":"K8s.Resource.NamedList.access!/1","doc":"Provides an accessor to a list of maps whereas each element in the list has a key named &quot;name&quot;. If no such element exists within the given list, an exception is raised. Examples iex&gt; get_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}], [K8s.Resource.NamedList.access!(&quot;key2&quot;), &quot;value&quot;]) &quot;value2&quot; iex&gt; get_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}], [K8s.Resource.NamedList.access!(&quot;key2&quot;)]) %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;} iex&gt; get_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access!(&quot;missing-key&quot;), &quot;value&quot;]) ** (ArgumentError) There is not item with name missing-key in the given named list. iex&gt; get_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access!(&quot;missing-key&quot;)]) ** (ArgumentError) There is not item with name missing-key in the given named list. iex&gt; put_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}], [K8s.Resource.NamedList.access!(&quot;key1&quot;), &quot;value&quot;], &quot;value_new&quot;) [%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value_new&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}] iex&gt; put_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access!(&quot;missing-key&quot;), &quot;value&quot;], &quot;value_new&quot;) ** (ArgumentError) There is not item with name missing-key in the given named list. iex&gt; pop_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}], [K8s.Resource.NamedList.access!(&quot;key1&quot;), &quot;value&quot;]) {&quot;value1&quot;, [%{&quot;name&quot; =&gt; &quot;key1&quot;}, %{&quot;name&quot; =&gt; &quot;key2&quot;, &quot;value&quot; =&gt; &quot;value2&quot;}]} iex&gt; pop_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access!(&quot;missing-key&quot;), &quot;value&quot;]) ** (ArgumentError) There is not item with name missing-key in the given named list. iex&gt; pop_in([%{&quot;name&quot; =&gt; &quot;key1&quot;, &quot;value&quot; =&gt; &quot;value1&quot;}], [K8s.Resource.NamedList.access!(&quot;missing-key&quot;)]) ** (ArgumentError) There is not item with name missing-key in the given named list.","ref":"K8s.Resource.NamedList.html#access!/1"},{"type":"module","title":"K8s.Resource.Utilization","doc":"Deserializers for CPU and Memory values","ref":"K8s.Resource.Utilization.html"},{"type":"function","title":"K8s.Resource.Utilization.cpu/1","doc":"Deserializes CPU quantity Examples Parses whole values iex&gt; K8s.Resource.Utilization . cpu ( &quot;3&quot; ) 3 Parses millicpu values iex&gt; K8s.Resource.Utilization . cpu ( &quot;500m&quot; ) 0.5 Parses decimal values iex&gt; K8s.Resource.Utilization . cpu ( &quot;1.5&quot; ) 1.5","ref":"K8s.Resource.Utilization.html#cpu/1"},{"type":"function","title":"K8s.Resource.Utilization.memory/1","doc":"Deserializes memory quantity Examples Parses whole values iex&gt; K8s.Resource.Utilization . memory ( &quot;1000000&quot; ) 1000000 Parses decimal values iex&gt; K8s.Resource.Utilization . memory ( &quot;10.75&quot; ) 10.75 Parses decimalSI values iex&gt; K8s.Resource.Utilization . memory ( &quot;10M&quot; ) 10000000 Parses binarySI suffixes iex&gt; K8s.Resource.Utilization . memory ( &quot;50Mi&quot; ) 52428800 Returns the numeric value when the suffix is unrecognized iex&gt; K8s.Resource.Utilization . memory ( &quot;50Foo&quot; ) 50","ref":"K8s.Resource.Utilization.html#memory/1"},{"type":"module","title":"K8s.Selector","doc":"Builds label selectors and field selectors for K8s.Operation s Examples Parse from a YAML map iex&gt; deployment = %{ ...&gt; &quot;kind&quot; =&gt; &quot;Deployment&quot; , ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;name&quot; =&gt; &quot;nginx&quot; , ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; , ...&gt; &quot;tier&quot; =&gt; &quot;backend&quot; ...&gt; } ...&gt; } , ...&gt; &quot;spec&quot; =&gt; %{ ...&gt; &quot;selector&quot; =&gt; %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; ...&gt; } ...&gt; } , ...&gt; &quot;template&quot; =&gt; %{ ...&gt; &quot;metadata&quot; =&gt; %{ ...&gt; &quot;labels&quot; =&gt; %{ ...&gt; &quot;app&quot; =&gt; &quot;nginx&quot; , ...&gt; &quot;tier&quot; =&gt; &quot;backend&quot; ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; } ...&gt; K8s.Selector . parse ( deployment ) % K8s.Selector { match_labels : %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } Provides a composable interface for building label selectors iex&gt; { &quot;component&quot; , &quot;redis&quot; } ...&gt; |&gt; K8s.Selector . label ( ) ...&gt; |&gt; K8s.Selector . label_not ( { &quot;foo&quot; , &quot;bar&quot; } ) ...&gt; |&gt; K8s.Selector . label_in ( { &quot;tier&quot; , &quot;cache&quot; } ) ...&gt; |&gt; K8s.Selector . label_not_in ( { &quot;environment&quot; , &quot;dev&quot; } ) ...&gt; |&gt; K8s.Selector . label_exists ( &quot;foo&quot; ) ...&gt; |&gt; K8s.Selector . label_does_not_exist ( &quot;bar&quot; ) % K8s.Selector { match_labels : %{ &quot;component&quot; =&gt; { &quot;=&quot; , &quot;redis&quot; } , &quot;foo&quot; =&gt; { &quot;!=&quot; , &quot;bar&quot; } } , match_expressions : [ %{ &quot;key&quot; =&gt; &quot;bar&quot; , &quot;operator&quot; =&gt; &quot;DoesNotExist&quot; } , %{ &quot;key&quot; =&gt; &quot;foo&quot; , &quot;operator&quot; =&gt; &quot;Exists&quot; } , %{ &quot;key&quot; =&gt; &quot;environment&quot; , &quot;operator&quot; =&gt; &quot;NotIn&quot; , &quot;values&quot; =&gt; [ &quot;dev&quot; ] } , %{ &quot;key&quot; =&gt; &quot;tier&quot; , &quot;operator&quot; =&gt; &quot;In&quot; , &quot;values&quot; =&gt; [ &quot;cache&quot; ] } ] } Provides a composable interface for adding selectors to K8s.Operation s. iex&gt; K8s.Client . get ( &quot;v1&quot; , :pods ) ...&gt; |&gt; K8s.Selector . label ( { &quot;app&quot; , &quot;nginx&quot; } ) ...&gt; |&gt; K8s.Selector . label_not ( %{ &quot;tier&quot; =&gt; &quot;backend&quot; } ) ...&gt; |&gt; K8s.Selector . label_in ( { &quot;environment&quot; , [ &quot;qa&quot; , &quot;prod&quot; ] } ) % K8s.Operation { data : nil , api_version : &quot;v1&quot; , query_params : [ labelSelector : % K8s.Selector { match_expressions : [ %{ &quot;key&quot; =&gt; &quot;environment&quot; , &quot;operator&quot; =&gt; &quot;In&quot; , &quot;values&quot; =&gt; [ &quot;qa&quot; , &quot;prod&quot; ] } ] , match_labels : %{ &quot;app&quot; =&gt; { &quot;=&quot; , &quot;nginx&quot; } , &quot;tier&quot; =&gt; { &quot;!=&quot; , &quot;backend&quot; } } } ] , method : :get , name : :pods , path_params : [ ] , verb : :get }","ref":"K8s.Selector.html"},{"type":"function","title":"K8s.Selector.field/1","doc":"fieldSelector helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . field ( { &quot;metadata.namespace&quot; , &quot;default&quot; } ) % K8s.Selector { match_fields : %{ &quot;metadata.namespace&quot; =&gt; { &quot;=&quot; , &quot;default&quot; } } } iex&gt; K8s.Selector . field ( %{ &quot;metadata.namespace&quot; =&gt; &quot;default&quot; , &quot;status.phase&quot; =&gt; &quot;Running&quot; } ) % K8s.Selector { match_fields : %{ &quot;metadata.namespace&quot; =&gt; { &quot;=&quot; , &quot;default&quot; } , &quot;status.phase&quot; =&gt; { &quot;=&quot; , &quot;Running&quot; } } }","ref":"K8s.Selector.html#field/1"},{"type":"function","title":"K8s.Selector.field/2","doc":"","ref":"K8s.Selector.html#field/2"},{"type":"function","title":"K8s.Selector.field_not/1","doc":"fieldSelector helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . field_not ( { &quot;metadata.namespace&quot; , &quot;default&quot; } ) % K8s.Selector { match_fields : %{ &quot;metadata.namespace&quot; =&gt; { &quot;!=&quot; , &quot;default&quot; } } } iex&gt; K8s.Selector . field ( %{ &quot;metadata.namespace&quot; =&gt; &quot;default&quot; , &quot;status.phase&quot; =&gt; &quot;Running&quot; } ) % K8s.Selector { match_fields : %{ &quot;metadata.namespace&quot; =&gt; { &quot;=&quot; , &quot;default&quot; } , &quot;status.phase&quot; =&gt; { &quot;=&quot; , &quot;Running&quot; } } }","ref":"K8s.Selector.html#field_not/1"},{"type":"function","title":"K8s.Selector.field_not/2","doc":"","ref":"K8s.Selector.html#field_not/2"},{"type":"function","title":"K8s.Selector.fields_to_s/1","doc":"Serializes a K8s.Selector to a fieldSelector query string. Examples iex&gt; selector = K8s.Selector . field ( { &quot;status.phase&quot; , &quot;Running&quot; } ) ...&gt; K8s.Selector . fields_to_s ( selector ) &quot;status.phase=Running&quot;","ref":"K8s.Selector.html#fields_to_s/1"},{"type":"function","title":"K8s.Selector.label/1","doc":"matchLabels helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . label ( { &quot;component&quot; , &quot;redis&quot; } ) % K8s.Selector { match_labels : %{ &quot;component&quot; =&gt; { &quot;=&quot; , &quot;redis&quot; } } } iex&gt; K8s.Selector . label ( %{ &quot;component&quot; =&gt; &quot;redis&quot; , &quot;env&quot; =&gt; &quot;prod&quot; } ) % K8s.Selector { match_labels : %{ &quot;component&quot; =&gt; { &quot;=&quot; , &quot;redis&quot; } , &quot;env&quot; =&gt; { &quot;=&quot; , &quot;prod&quot; } } }","ref":"K8s.Selector.html#label/1"},{"type":"function","title":"K8s.Selector.label/2","doc":"matchLabels helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . label ( { &quot;component&quot; , &quot;redis&quot; } ) ...&gt; |&gt; K8s.Selector . label ( { &quot;environment&quot; , &quot;dev&quot; } ) % K8s.Selector { match_labels : %{ &quot;component&quot; =&gt; { &quot;=&quot; , &quot;redis&quot; } , &quot;environment&quot; =&gt; { &quot;=&quot; , &quot;dev&quot; } } }","ref":"K8s.Selector.html#label/2"},{"type":"function","title":"K8s.Selector.label_does_not_exist/1","doc":"DoesNotExist expression helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . label_does_not_exist ( &quot;environment&quot; ) % K8s.Selector { match_expressions : [ %{ &quot;key&quot; =&gt; &quot;environment&quot; , &quot;operator&quot; =&gt; &quot;DoesNotExist&quot; } ] }","ref":"K8s.Selector.html#label_does_not_exist/1"},{"type":"function","title":"K8s.Selector.label_does_not_exist/2","doc":"","ref":"K8s.Selector.html#label_does_not_exist/2"},{"type":"function","title":"K8s.Selector.label_exists/1","doc":"Exists expression helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . label_exists ( &quot;environment&quot; ) % K8s.Selector { match_expressions : [ %{ &quot;key&quot; =&gt; &quot;environment&quot; , &quot;operator&quot; =&gt; &quot;Exists&quot; } ] }","ref":"K8s.Selector.html#label_exists/1"},{"type":"function","title":"K8s.Selector.label_exists/2","doc":"","ref":"K8s.Selector.html#label_exists/2"},{"type":"function","title":"K8s.Selector.label_in/1","doc":"In expression helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . label_in ( { &quot;component&quot; , &quot;redis&quot; } ) % K8s.Selector { match_expressions : [ %{ &quot;key&quot; =&gt; &quot;component&quot; , &quot;operator&quot; =&gt; &quot;In&quot; , &quot;values&quot; =&gt; [ &quot;redis&quot; ] } ] }","ref":"K8s.Selector.html#label_in/1"},{"type":"function","title":"K8s.Selector.label_in/2","doc":"","ref":"K8s.Selector.html#label_in/2"},{"type":"function","title":"K8s.Selector.label_not/1","doc":"matchLabels helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . label_not ( { &quot;component&quot; , &quot;redis&quot; } ) % K8s.Selector { match_labels : %{ &quot;component&quot; =&gt; { &quot;!=&quot; , &quot;redis&quot; } } } iex&gt; K8s.Selector . label_not ( %{ &quot;component&quot; =&gt; &quot;redis&quot; , &quot;env&quot; =&gt; &quot;prod&quot; } ) % K8s.Selector { match_labels : %{ &quot;component&quot; =&gt; { &quot;!=&quot; , &quot;redis&quot; } , &quot;env&quot; =&gt; { &quot;!=&quot; , &quot;prod&quot; } } }","ref":"K8s.Selector.html#label_not/1"},{"type":"function","title":"K8s.Selector.label_not/2","doc":"matchLabels helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . label_not ( { &quot;component&quot; , &quot;redis&quot; } ) ...&gt; |&gt; K8s.Selector . label_not ( { &quot;environment&quot; , &quot;dev&quot; } ) % K8s.Selector { match_labels : %{ &quot;component&quot; =&gt; { &quot;!=&quot; , &quot;redis&quot; } , &quot;environment&quot; =&gt; { &quot;!=&quot; , &quot;dev&quot; } } }","ref":"K8s.Selector.html#label_not/2"},{"type":"function","title":"K8s.Selector.label_not_in/1","doc":"NotIn expression helper that creates a composable K8s.Selector . Examples iex&gt; K8s.Selector . label_not_in ( { &quot;component&quot; , &quot;redis&quot; } ) % K8s.Selector { match_expressions : [ %{ &quot;key&quot; =&gt; &quot;component&quot; , &quot;operator&quot; =&gt; &quot;NotIn&quot; , &quot;values&quot; =&gt; [ &quot;redis&quot; ] } ] }","ref":"K8s.Selector.html#label_not_in/1"},{"type":"function","title":"K8s.Selector.label_not_in/2","doc":"","ref":"K8s.Selector.html#label_not_in/2"},{"type":"function","title":"K8s.Selector.labels_to_s/1","doc":"Serializes a K8s.Selector to a labelSelector query string. Examples iex&gt; selector = K8s.Selector . label ( { &quot;component&quot; , &quot;redis&quot; } ) ...&gt; K8s.Selector . labels_to_s ( selector ) &quot;component=redis&quot;","ref":"K8s.Selector.html#labels_to_s/1"},{"type":"function","title":"K8s.Selector.match_expression?/2","doc":"Checks whether a resource matches a single selector matchExpressions Examples When an In expression matches iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;prod&quot; } } } ...&gt; expr = %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;env&quot; , &quot;values&quot; =&gt; [ &quot;prod&quot; , &quot;qa&quot; ] } ...&gt; K8s.Selector . match_expression? ( resource , expr ) true When an In expression doesnt match iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;dev&quot; } } } ...&gt; expr = %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;env&quot; , &quot;values&quot; =&gt; [ &quot;prod&quot; , &quot;qa&quot; ] } ...&gt; K8s.Selector . match_expression? ( resource , expr ) false When an NotIn expression matches iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;dev&quot; } } } ...&gt; expr = %{ &quot;operator&quot; =&gt; &quot;NotIn&quot; , &quot;key&quot; =&gt; &quot;env&quot; , &quot;values&quot; =&gt; [ &quot;prod&quot; ] } ...&gt; K8s.Selector . match_expression? ( resource , expr ) true When an NotIn expression doesnt match iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;dev&quot; } } } ...&gt; expr = %{ &quot;operator&quot; =&gt; &quot;NotIn&quot; , &quot;key&quot; =&gt; &quot;env&quot; , &quot;values&quot; =&gt; [ &quot;dev&quot; ] } ...&gt; K8s.Selector . match_expression? ( resource , expr ) false When an Exists expression matches iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;dev&quot; } } } ...&gt; expr = %{ &quot;operator&quot; =&gt; &quot;Exists&quot; , &quot;key&quot; =&gt; &quot;env&quot; } ...&gt; K8s.Selector . match_expression? ( resource , expr ) true When an Exists expression doesnt match iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;dev&quot; } } } ...&gt; expr = %{ &quot;operator&quot; =&gt; &quot;Exists&quot; , &quot;key&quot; =&gt; &quot;tier&quot; } ...&gt; K8s.Selector . match_expression? ( resource , expr ) false When an DoesNotExist expression matches iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;dev&quot; } } } ...&gt; expr = %{ &quot;operator&quot; =&gt; &quot;DoesNotExist&quot; , &quot;key&quot; =&gt; &quot;tier&quot; } ...&gt; K8s.Selector . match_expression? ( resource , expr ) true When an DoesNotExist expression doesnt match iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;dev&quot; } } } ...&gt; expr = %{ &quot;operator&quot; =&gt; &quot;DoesNotExist&quot; , &quot;key&quot; =&gt; &quot;env&quot; } ...&gt; K8s.Selector . match_expression? ( resource , expr ) false","ref":"K8s.Selector.html#match_expression?/2"},{"type":"function","title":"K8s.Selector.match_expressions?/2","doc":"Checks if a K8s.Resource matches all matchExpressions using a logical AND Examples Accepts K8s.Selector s: iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;prod&quot; , &quot;tier&quot; =&gt; &quot;frontend&quot; } } } ...&gt; expr1 = %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;env&quot; , &quot;values&quot; =&gt; [ &quot;prod&quot; , &quot;qa&quot; ] } ...&gt; expr2 = %{ &quot;operator&quot; =&gt; &quot;Exists&quot; , &quot;key&quot; =&gt; &quot;tier&quot; } ...&gt; selector = % K8s.Selector { match_expressions : [ expr1 , expr2 ] } ...&gt; K8s.Selector . match_expressions? ( resource , selector ) true Accepts map s: iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;prod&quot; , &quot;tier&quot; =&gt; &quot;frontend&quot; } } } ...&gt; expr1 = %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;env&quot; , &quot;values&quot; =&gt; [ &quot;prod&quot; , &quot;qa&quot; ] } ...&gt; expr2 = %{ &quot;operator&quot; =&gt; &quot;Exists&quot; , &quot;key&quot; =&gt; &quot;tier&quot; } ...&gt; K8s.Selector . match_expressions? ( resource , [ expr1 , expr2 ] ) true Returns false when not matching all expressions: iex&gt; resource = %{ &quot;kind&quot; =&gt; &quot;Node&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;env&quot; =&gt; &quot;prod&quot; , &quot;tier&quot; =&gt; &quot;frontend&quot; } } } ...&gt; expr1 = %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;env&quot; , &quot;values&quot; =&gt; [ &quot;prod&quot; , &quot;qa&quot; ] } ...&gt; expr2 = %{ &quot;operator&quot; =&gt; &quot;Exists&quot; , &quot;key&quot; =&gt; &quot;foo&quot; } ...&gt; K8s.Selector . match_expressions? ( resource , [ expr1 , expr2 ] ) false","ref":"K8s.Selector.html#match_expressions?/2"},{"type":"function","title":"K8s.Selector.match_label?/3","doc":"Checks if a K8s.Resource matches a single label","ref":"K8s.Selector.html#match_label?/3"},{"type":"function","title":"K8s.Selector.match_labels?/2","doc":"Checks if a K8s.Resource matches all matchLabels using a logcal AND Examples Accepts K8s.Selector s: iex&gt; labels = %{ &quot;env&quot; =&gt; &quot;prod&quot; , &quot;tier&quot; =&gt; &quot;frontend&quot; } ...&gt; selector = % K8s.Selector { match_labels : labels } ...&gt; resource = K8s.Resource . build ( &quot;v1&quot; , &quot;Pod&quot; , &quot;default&quot; , &quot;test&quot; , labels ) ...&gt; K8s.Selector . match_labels? ( resource , selector ) true Accepts maps: iex&gt; labels = %{ &quot;env&quot; =&gt; &quot;prod&quot; , &quot;tier&quot; =&gt; &quot;frontend&quot; } ...&gt; resource = K8s.Resource . build ( &quot;v1&quot; , &quot;Pod&quot; , &quot;default&quot; , &quot;test&quot; , labels ) ...&gt; K8s.Selector . match_labels? ( resource , labels ) true Returns false when not matching all labels: iex&gt; not_a_match = %{ &quot;env&quot; =&gt; &quot;prod&quot; , &quot;tier&quot; =&gt; &quot;frontend&quot; , &quot;nope&quot; =&gt; &quot;not-a-match&quot; } ...&gt; resource = K8s.Resource . build ( &quot;v1&quot; , &quot;Pod&quot; , &quot;default&quot; , &quot;test&quot; , %{ &quot;env&quot; =&gt; &quot;prod&quot; , &quot;tier&quot; =&gt; &quot;frontend&quot; } ) ...&gt; K8s.Selector . match_labels? ( resource , not_a_match ) false","ref":"K8s.Selector.html#match_labels?/2"},{"type":"function","title":"K8s.Selector.parse/1","doc":"Parses a &quot;selector&quot; map of &quot;matchLabels&quot; and &quot;matchExpressions&quot; Examples iex&gt; selector = %{ ...&gt; &quot;matchLabels&quot; =&gt; %{ &quot;component&quot; =&gt; &quot;redis&quot; } , ...&gt; &quot;matchExpressions&quot; =&gt; [ ...&gt; %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;tier&quot; , &quot;values&quot; =&gt; [ &quot;cache&quot; ] } , ...&gt; %{ &quot;operator&quot; =&gt; &quot;NotIn&quot; , &quot;key&quot; =&gt; &quot;environment&quot; , &quot;values&quot; =&gt; [ &quot;dev&quot; ] } ...&gt; ] ...&gt; } ...&gt; K8s.Selector . parse ( selector ) % K8s.Selector { match_labels : %{ &quot;component&quot; =&gt; &quot;redis&quot; } , match_expressions : [ %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;tier&quot; , &quot;values&quot; =&gt; [ &quot;cache&quot; ] } , %{ &quot;operator&quot; =&gt; &quot;NotIn&quot; , &quot;key&quot; =&gt; &quot;environment&quot; , &quot;values&quot; =&gt; [ &quot;dev&quot; ] } ] }","ref":"K8s.Selector.html#parse/1"},{"type":"function","title":"K8s.Selector.serialize_match/1","doc":"Returns a fieldSelector query string value for a set of field selectors. Examples Builds a query string for a single field ( kubectl get pods --field-selector status.phase=Running ): iex&gt; K8s.Selector . serialize_match ( %{ &quot;status.phase&quot; =&gt; { &quot;=&quot; , &quot;Running&quot; } } ) [ &quot;status.phase=Running&quot; ] Builds a query string for multiple fields ( kubectl get pods --field-selector status.phase=Running,metadata.namespace!=default ): iex&gt; K8s.Selector . serialize_match ( %{ &quot;metadata.namespace&quot; =&gt; { &quot;!=&quot; , &quot;default&quot; } , &quot;status.phase&quot; =&gt; { &quot;=&quot; , &quot;Running&quot; } } ) [ &quot;metadata.namespace!=default&quot; , &quot;status.phase=Running&quot; ]","ref":"K8s.Selector.html#serialize_match/1"},{"type":"function","title":"K8s.Selector.serialize_match_expressions/1","doc":"Returns a labelSelector query string value for a set of label expressions. For != matches, use a NotIn set-based expression. Examples Builds a query string for In expressions ( kubectl get pods -l 'environment in (production,qa),tier in (frontend) ): iex&gt; expressions = [ ...&gt; %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;environment&quot; , &quot;values&quot; =&gt; [ &quot;production&quot; , &quot;qa&quot; ] } , ...&gt; %{ &quot;operator&quot; =&gt; &quot;In&quot; , &quot;key&quot; =&gt; &quot;tier&quot; , &quot;values&quot; =&gt; [ &quot;frontend&quot; ] } , ...&gt; ] ...&gt; K8s.Selector . serialize_match_expressions ( expressions ) [ &quot;environment in (production,qa)&quot; , &quot;tier in (frontend)&quot; ] Builds a query string for NotIn expressions ( kubectl get pods -l 'environment notin (frontend) ): iex&gt; expressions = [ ...&gt; %{ &quot;operator&quot; =&gt; &quot;NotIn&quot; , &quot;key&quot; =&gt; &quot;environment&quot; , &quot;values&quot; =&gt; [ &quot;frontend&quot; ] } ...&gt; ] ...&gt; K8s.Selector . serialize_match_expressions ( expressions ) [ &quot;environment notin (frontend)&quot; ] Builds a query string for Exists expressions ( kubectl get pods -l 'environment' ): iex&gt; expressions = [ ...&gt; %{ &quot;operator&quot; =&gt; &quot;Exists&quot; , &quot;key&quot; =&gt; &quot;environment&quot; } ...&gt; ] ...&gt; K8s.Selector . serialize_match_expressions ( expressions ) [ &quot;environment&quot; ] Builds a query string for DoesNotExist expressions ( kubectl get pods -l '!environment' ): iex&gt; expressions = [ ...&gt; %{ &quot;operator&quot; =&gt; &quot;DoesNotExist&quot; , &quot;key&quot; =&gt; &quot;environment&quot; } ...&gt; ] ...&gt; K8s.Selector . serialize_match_expressions ( expressions ) [ &quot;!environment&quot; ]","ref":"K8s.Selector.html#serialize_match_expressions/1"},{"type":"function","title":"K8s.Selector.serialize_match_labels/1","doc":"See K8s.Selector.serialize_match/1 .","ref":"K8s.Selector.html#serialize_match_labels/1"},{"type":"function","title":"K8s.Selector.to_s/1","doc":"Serializes a K8s.Selector to a labelSelector query string. Examples iex&gt; selector = K8s.Selector.label({&quot;component&quot;, &quot;redis&quot;}) ...&gt; K8s.Selector.to_s(selector) &quot;component=redis&quot;","ref":"K8s.Selector.html#to_s/1"},{"type":"type","title":"K8s.Selector.selector_or_operation_t/0","doc":"","ref":"K8s.Selector.html#t:selector_or_operation_t/0"},{"type":"type","title":"K8s.Selector.t/0","doc":"","ref":"K8s.Selector.html#t:t/0"},{"type":"module","title":"K8s.Sys.Event","doc":"Telemetry event defimitions for this library","ref":"K8s.Sys.Event.html"},{"type":"function","title":"K8s.Sys.Event.events/0","doc":"See K8s.Sys.Telemetry.events/0 .","ref":"K8s.Sys.Event.html#events/0"},{"type":"module","title":"K8s.Sys.Logger","doc":"Attaches telemetry events to the Elixir Logger","ref":"K8s.Sys.Logger.html"},{"type":"function","title":"K8s.Sys.Logger.attach/0","doc":"Attaches telemetry events to the Elixir Logger","ref":"K8s.Sys.Logger.html#attach/0"},{"type":"macro","title":"K8s.Sys.Logger.log_prefix/1","doc":"","ref":"K8s.Sys.Logger.html#log_prefix/1"},{"type":"module","title":"K8s.Sys.Telemetry","doc":"Telemetry event defimitions for this library","ref":"K8s.Sys.Telemetry.html"},{"type":"function","title":"K8s.Sys.Telemetry.events/0","doc":"","ref":"K8s.Sys.Telemetry.html#events/0"},{"type":"module","title":"K8s.Version","doc":"Kubernetes API Versioning","ref":"K8s.Version.html"},{"type":"function","title":"K8s.Version.alpha/1","doc":"Returns only alpha versions Examples iex&gt; K8s.Version . alpha ( [ &quot;v1alpha1&quot; , &quot;v1&quot; , &quot;v2beta1&quot; ] ) [ % K8s.Version { major : 1 , minor : &quot;alpha&quot; , patch : 1 } ]","ref":"K8s.Version.html#alpha/1"},{"type":"function","title":"K8s.Version.beta/1","doc":"Returns only beta versions Examples iex&gt; K8s.Version . beta ( [ &quot;v1alpha1&quot; , &quot;v1&quot; , &quot;v2beta1&quot; ] ) [ % K8s.Version { major : 2 , minor : &quot;beta&quot; , patch : 1 } ]","ref":"K8s.Version.html#beta/1"},{"type":"function","title":"K8s.Version.edge/1","doc":"Retuns all non-stable versions Examples iex&gt; K8s.Version . edge ( [ &quot;v1alpha1&quot; , &quot;v1&quot; , &quot;v2beta1&quot; ] ) [ % K8s.Version { major : 1 , minor : &quot;alpha&quot; , patch : 1 } , % K8s.Version { major : 2 , minor : &quot;beta&quot; , patch : 1 } ]","ref":"K8s.Version.html#edge/1"},{"type":"function","title":"K8s.Version.parse/1","doc":"Parses a Kubernetes API version into a K8s.Version struct Examples iex&gt; K8s.Version . parse ( &quot;v1&quot; ) % K8s.Version { major : 1 , minor : &quot;stable&quot; , patch : nil } iex&gt; K8s.Version . parse ( &quot;v1beta2&quot; ) % K8s.Version { major : 1 , minor : &quot;beta&quot; , patch : 2 } iex&gt; K8s.Version . parse ( &quot;v1alpha1&quot; ) % K8s.Version { major : 1 , minor : &quot;alpha&quot; , patch : 1 }","ref":"K8s.Version.html#parse/1"},{"type":"function","title":"K8s.Version.recommended/1","doc":"Returns the recommended version from a list of versions. It will return the most stable version if any, otherwise the newest &quot; edge &quot; version. Examples iex&gt; K8s.Version . recommended ( [ &quot;v1beta1&quot; , &quot;v1&quot; , &quot;v2&quot; ] ) &quot;v2&quot; iex&gt; K8s.Version . recommended ( [ &quot;v1beta1&quot; , &quot;v1&quot; ] ) &quot;v1&quot; iex&gt; K8s.Version . recommended ( [ &quot;v1beta2&quot; , &quot;v1beta1&quot; ] ) &quot;v1beta2&quot; iex&gt; K8s.Version . recommended ( [ &quot;v1alpha1&quot; , &quot;v1alpha2&quot; , &quot;v1beta1&quot; ] ) &quot;v1beta1&quot;","ref":"K8s.Version.html#recommended/1"},{"type":"function","title":"K8s.Version.serialize/1","doc":"Returns only stable versions Examples iex&gt; K8s.Version . serialize ( % K8s.Version { major : 1 , minor : &quot;stable&quot; , patch : nil } ) &quot;v1&quot; iex&gt; K8s.Version . serialize ( % K8s.Version { major : 1 , minor : &quot;beta&quot; , patch : 1 } ) &quot;v1beta1&quot; iex&gt; K8s.Version . serialize ( % K8s.Version { major : 1 , minor : &quot;alpha&quot; , patch : 1 } ) &quot;v1alpha1&quot;","ref":"K8s.Version.html#serialize/1"},{"type":"function","title":"K8s.Version.sort/1","doc":"Sorts a list of K8s.Version s Examples iex&gt; raw_versions = Enum . shuffle ( [ &quot;v1&quot; , &quot;v2beta1&quot; , &quot;v2&quot; , &quot;v1alpha1&quot; , &quot;v1alpha2&quot; ] ) iex&gt; versions = raw_versions |&gt; Enum . map ( &amp; ( K8s.Version . parse ( &amp;1 ) ) ) iex&gt; sorted_versions = versions |&gt; K8s.Version . sort ( ) iex&gt; sorted_versions |&gt; Enum . map ( &amp; ( K8s.Version . serialize ( &amp;1 ) ) ) [ &quot;v2&quot; , &quot;v1&quot; , &quot;v2beta1&quot; , &quot;v1alpha2&quot; , &quot;v1alpha1&quot; ]","ref":"K8s.Version.html#sort/1"},{"type":"function","title":"K8s.Version.stable/1","doc":"Returns only stable versions Examples iex&gt; K8s.Version . stable ( [ &quot;v1alpha1&quot; , &quot;v1&quot; , &quot;v2beta1&quot; ] ) [ % K8s.Version { major : 1 , minor : &quot;stable&quot; , patch : nil } ]","ref":"K8s.Version.html#stable/1"},{"type":"type","title":"K8s.Version.t/0","doc":"","ref":"K8s.Version.html#t:t/0"},{"type":"exception","title":"K8s.Client.APIError","doc":"Kubernetes API Error Any HTTP Error with JSON error payload","ref":"K8s.Client.APIError.html"},{"type":"function","title":"K8s.Client.APIError.from_kubernetes_error/1","doc":"","ref":"K8s.Client.APIError.html#from_kubernetes_error/1"},{"type":"type","title":"K8s.Client.APIError.t/0","doc":"","ref":"K8s.Client.APIError.html#t:t/0"},{"type":"exception","title":"K8s.Client.HTTPError","doc":"Kubernetes API Error Any HTTP Error with JSON error payload","ref":"K8s.Client.HTTPError.html"},{"type":"function","title":"K8s.Client.HTTPError.from_exception/1","doc":"","ref":"K8s.Client.HTTPError.html#from_exception/1"},{"type":"function","title":"K8s.Client.HTTPError.new/1","doc":"","ref":"K8s.Client.HTTPError.html#new/1"},{"type":"type","title":"K8s.Client.HTTPError.t/0","doc":"","ref":"K8s.Client.HTTPError.html#t:t/0"},{"type":"exception","title":"K8s.Conn.Error","doc":"","ref":"K8s.Conn.Error.html"},{"type":"type","title":"K8s.Conn.Error.t/0","doc":"","ref":"K8s.Conn.Error.html#t:t/0"},{"type":"exception","title":"K8s.Discovery.Error","doc":"","ref":"K8s.Discovery.Error.html"},{"type":"type","title":"K8s.Discovery.Error.t/0","doc":"","ref":"K8s.Discovery.Error.html#t:t/0"},{"type":"exception","title":"K8s.Operation.Error","doc":"","ref":"K8s.Operation.Error.html"},{"type":"type","title":"K8s.Operation.Error.t/0","doc":"","ref":"K8s.Operation.Error.html#t:t/0"},{"type":"extras","title":"K8s","doc":"K8s - Kubernetes API Client for Elixir","ref":"readme.html"},{"type":"extras","title":"K8s - Features","doc":"A client API for humans 👩🏼🧑👩🏻👩🏽👩🏾🧑🏻🧑🏽🧑🧑🏾👨🏼👨🏾👨🏿 🔮 Kubernetes resources, groups, and CRDs are autodiscovered at boot time. No swagger file to include or override. Client supports standard HTTP calls, async batches, wait on status ⏲️, and watchers 👀 ⚙️ HTTP Request middleware Multiple clusters ⚓ ⚓ ⚓ 🔐 Multiple authentication credentials 🤖 serviceaccount token 📜 certificate auth-provider Pluggable auth providers! 🆗 Tested against Kubernetes versions 1.10+ and master 🛠️ CRD support 📈 Integrated with :telemetry ℹ️ Kubernetes resource and version helper functions 🧰 Kube config file parsing 🏎️ Macro free; fast compile &amp; fast startup","ref":"readme.html#features"},{"type":"extras","title":"K8s - Installation","doc":"The package can be installed by adding :k8s to your list of dependencies in mix.exs : def deps do [ { :k8s , &quot;~&gt; 2.0&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"K8s - Usage","doc":"Check out the Usage Guide for in-depth examples. Most functions are also written using doctests. K8s.Client doctests K8s.Conn doctests K8s.Resource doctests K8s.Version doctests If you are interested in building Kubernetes Operators or Schedulers, check out Bonny .","ref":"readme.html#usage"},{"type":"extras","title":"K8s - tl;dr Examples","doc":"Configure a cluster connection Cluster connections can be created using the K8s.Conn module. K8s.Conn.from_file/1 will use the current context in your kubeconfig. { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) K8s.Conn.from_file/2 accepts a keyword list to set the :user , :cluster , and/or :context Connections can also be created in-cluster from a service account. { :ok , conn } = K8s.Conn . from_service_account ( &quot;/path/to/service-account/directory&quot; ) Check out the connection guide for additional details. Creating a deployment { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) opts = [ namespace : &quot;default&quot; , name : &quot;nginx&quot; , image : &quot;nginx:nginx:1.7.9&quot; ] { :ok , resource } = K8s.Resource . from_file ( &quot;priv/deployment.yaml&quot; , opts ) operation = K8s.Client . create ( resource ) { :ok , deployment } = K8s.Client . run ( conn , operation ) Listing deployments In a namespace: { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) operation = K8s.Client . list ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : &quot;prod&quot; ) { :ok , deployments } = K8s.Client . run ( conn , operation ) Across all namespaces: { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) operation = K8s.Client . list ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : :all ) { :ok , deployments } = K8s.Client . run ( conn , operation ) Getting a deployment { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) operation = K8s.Client . get ( &quot;apps/v1&quot; , :deployment , [ namespace : &quot;default&quot; , name : &quot;nginx-deployment&quot; ] ) { :ok , deployment } = K8s.Client . run ( conn , operation )","ref":"readme.html#tl-dr-examples"},{"type":"extras","title":"Changelog","doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - Unreleased","doc":"","ref":"changelog.html#unreleased"},{"type":"extras","title":"Changelog - [2.3.0] - 2023-05-14","doc":"Added K8s.Client.connect/4 - Support connecting to pods/log subresource. - #254 , #255 K8s.Conn.from_env/2 - Generates configuration from a file defined by an env variable. - #251 K8s.Conn - Better hexdocs","ref":"changelog.html#2-3-0-2023-05-14"},{"type":"extras","title":"Changelog - [2.2.0] - 2023-03-27","doc":"Fixed K8s.Conn.Auth.Exec - Define default value for :args - #240 Added K8s.Conn.Auth.Azure - Azure auth provider added by @hanspagh - #162 , #225","ref":"changelog.html#2-2-0-2023-03-27"},{"type":"extras","title":"Changelog - [2.1.1] - 2023-03-02","doc":"Fixed Watcher reset resource version for objects with a &quot;message&quot; field. - #232 , #231","ref":"changelog.html#2-1-1-2023-03-02"},{"type":"extras","title":"Changelog - [2.1.0] - 2023-02-25","doc":"Added Added further PATCH mechanisms - #229 Add opts to K8s.Conn.from_file/N and K8s.Conn.from_service_account/N in order to be able to pass :insecure_skip_tls_verify option directly. - #230 , #203","ref":"changelog.html#2-1-0-2023-02-25"},{"type":"extras","title":"Changelog - [2.0.3] - 2023-02-17","doc":"Fixed A regression introduced in 2.0.2: superfluous call to Genserver.reply() was removed.","ref":"changelog.html#2-0-3-2023-02-17"},{"type":"extras","title":"Changelog - [2.0.2] - 2023-02-16","doc":"Fixed Resume watch when API server has gone away - #226 , #222","ref":"changelog.html#2-0-2-2023-02-16"},{"type":"extras","title":"Changelog - [2.0.1] - 2023-02-12","doc":"Fixed Requests with large bodies are failing - #221 , #220","ref":"changelog.html#2-0-1-2023-02-12"},{"type":"extras","title":"Changelog - [2.0.0] - 2023-01-27","doc":"This version comes with some breaking changes. Please refer to the migrations guide for help on how to migrate your projects to this version. Added K8s.Selector.label_not/N , K8s.Selector.field/N and K8s.Selector.field_not/N - Support for field selectors ( #117 ) K8s.Client.Provider.stream/5 callback was added to the behaviour K8s.Client.Runner.Base.stream/3 K8s.Client.Provider.stream_to/6 callback was added to the behaviour K8s.Client.Runner.Base.stream_to/4 K8s.Client.MintHTTPProvider - The mint client implementation K8s.Client.HTTPTestHelper - to be used in tests (resides in lib/ so it can be used by dependents) Open :connect operations (connections) now accept messages to be sent to pods if using K8s.Client.stream_to/N K8s.Client.put_conn/2 to add pielining support to the Client API Changed K8s.Client.Provider behaviour was adapted to the new internal architecture K8s.Client.watch/N now returns a :watch or :watch_all_namespaces operation to be passed to K8s.Client.stream/N Websockex was replaced by Mint.WebSocket Removed K8s.Client.HTTPProvider was removed in favor of K8s.Client.MintHTTPProvider The :stream_to in http_opts was removed in favor of K8s.Client.stream_to/N and K8s.Client.stream/N . K8s.Client.DynamicWebSocketProvider was removed. Use K8s.Client.DynamcHTTPProvider.websocket* functions instead . Breaking changes Tests using the DynamicHTTPProvider which work with watch_and_stream are going to need to be changed. The HTTP mocks now need to implement the stream/5 callback. (See K8s.Client.Runner.Watch.StreamTest on this branch for examples)d. K8s.Client.DynamicWebSocketProvider was removed in favor of K8s.Client.DynamcHTTPProvider.websocket* functions. The :stream_to in http_opts is not supported anymore. Use K8s.Client.stream/N and K8s.Client.stream_to/N instead. Errors are encapsulated in K8s.Client.HTTPError headers/1 callback was removed from K8s.Client.Provider behaviour. K8s.Client.HTTPProvider (HTTPoison implementation) was removed. K8s.Client.watch/N now returns a :watch or :watch_all_namespaces operation to be passed to K8s.Client.stream/N Fixed Update PKI.cert_from_map/2 to support fully qualified domain names (FQDN) - Fix for K8s.Conn.from_file/1 ( #164 )","ref":"changelog.html#2-0-0-2023-01-27"},{"type":"extras","title":"Changelog - [2.0.0-rc.6] - 2023-01-19","doc":"Fixed Unable to parse response (invalid JSON) ( #215 )","ref":"changelog.html#2-0-0-rc-6-2023-01-19"},{"type":"extras","title":"Changelog - [2.0.0-rc.5] - 2023-01-08","doc":"Changed K8s.Client.Mint.HTTPAdapter - Handle Elixir streams separately from stream_to .","ref":"changelog.html#2-0-0-rc-5-2023-01-08"},{"type":"extras","title":"Changelog - [2.0.0-rc.4] - 2023-01-07","doc":"Added :poolboy - Pooling for HTTP/1 connections K8s.Client.Mint.HTTPAdapter - Monitor caller and cleanup state upon :DOWN","ref":"changelog.html#2-0-0-rc-4-2023-01-07"},{"type":"extras","title":"Changelog - [2.0.0-rc.3] - 2023-01-01","doc":"Fixed K8s.Client.Mint.ConnectionRegistry - closed connections were not re-established. K8s.Client.Mint.Request.HTTP - Add missing struct field :waiting","ref":"changelog.html#2-0-0-rc-3-2023-01-01"},{"type":"extras","title":"Changelog - [2.0.0-rc.2] - 2022-12-31","doc":"Added K8s.Client.Mint.HTTPAdapter - A GenServer handling Mint.HTTP connections. K8s.Client.Mint.ConnectionRegistry - The registry for open HTTP/2 connections","ref":"changelog.html#2-0-0-rc-2-2022-12-31"},{"type":"extras","title":"Changelog - [2.0.0-rc.1] - 2022-12-19","doc":"Fixed K8s.Client.Mint.WebSocket - Close websocket if process is terminated","ref":"changelog.html#2-0-0-rc-1-2022-12-19"},{"type":"extras","title":"Changelog - [2.0.0-rc.0] - 2022-12-14","doc":"This version comes with some breaking changes. Please refer to the migrations guide for help on how to migrate your projects to this version. Added K8s.Selector.label_not/N , K8s.Selector.field/N and K8s.Selector.field_not/N - Support for field selectors ( #117 ) K8s.Client.Provider.stream/5 callback was added to the behaviour K8s.Client.Runner.Base.stream/3 K8s.Client.Provider.stream_to/6 callback was added to the behaviour K8s.Client.Runner.Base.stream_to/4 K8s.Client.MintHTTPProvider - The mint client implementation K8s.Client.HTTPTestHelper - to be used in tests (resides in lib/ so it can be used by dependents) Open :connect operations (connections) now accept messages to be sent to pods K8s.Client.put_conn/2 to add pielining support to the Client API Changed K8s.Client.Provider behaviour was adapted to the new internal architecture K8s.Client.watch/N now returns a :watch or :watch_all_namespaces operation to be passed to K8s.Client.stream/N Websockex was replaced by Mint.WebSocket Removed K8s.Client.HTTPProvider was removed in favor of K8s.Client.MintHTTPProvider The :stream_to in http_opts was removed in favor of K8s.Client.stream_to/N and K8s.Client.stream/N . K8s.Client.DynamicWebSocketProvider was removed. Use K8s.Client.DynamcHTTPProvider.websocket* functions instead . Breaking changes Tests using the DynamicHTTPProvider which work with watch_and_stream are going to need to be changed. The HTTP mocks now need to implement the stream/5 callback. (See K8s.Client.Runner.Watch.StreamTest on this branch for examples)d. K8s.Client.DynamicWebSocketProvider was removed in favor of K8s.Client.DynamcHTTPProvider.websocket* functions. The :stream_to in http_opts is not supported anymore. Use K8s.Client.stream/N and K8s.Client.stream_to/N instead. Errors are encapsulated in K8s.Client.HTTPError headers/1 callback was removed from K8s.Client.Provider behaviour. K8s.Client.HTTPProvider (HTTPoison implementation) was removed. K8s.Client.watch/N now returns a :watch or :watch_all_namespaces operation to be passed to K8s.Client.stream/N Fixed Update PKI.cert_from_map/2 to support fully qualified domain names (FQDN) - Fix for K8s.Conn.from_file/1 ( #164 )","ref":"changelog.html#2-0-0-rc-0-2022-12-14"},{"type":"extras","title":"Changelog - [1.2.0] - 2022-12-07","doc":"Added K8s.Selector.label_not/N , K8s.Selector.field/N and K8s.Selector.field_not/N - Support for field selectors ( #117 ) K8s.Client.connect/3 - Executes a command in a Pod #190","ref":"changelog.html#1-2-0-2022-12-07"},{"type":"extras","title":"Changelog - [1.1.10] - 2022-10-30","doc":"Fixed K8s.Client.run/2 : spec updated to include K8s.Discovery.Error.t/0 in possible error structs","ref":"changelog.html#1-1-10-2022-10-30"},{"type":"extras","title":"Changelog - [1.1.9] - 2022-10-28","doc":"Fixed K8s.Client.run/2 : spec updated to include K8s.Client.APIError.t/0 in possible error structs ( #189 ) K8s.Operation.Path.build/1 : Allow namespace to be nil","ref":"changelog.html#1-1-9-2022-10-28"},{"type":"extras","title":"Changelog - [1.1.8] - 2022-10-26","doc":"Fixed K8s.Client.watch_and_stream/2 : Get resource vesrion before creating the Stream resource in order to not miss anything. ( #187 )","ref":"changelog.html#1-1-8-2022-10-26"},{"type":"extras","title":"Changelog - [1.1.7] - 2022-10-15","doc":"Fixed Fix protocol implementations in Elixir 1.14.1: Replace __MODULE__ with actual module name. #185 Match subresources when the kind does not equal the subresource ( #184 )","ref":"changelog.html#1-1-7-2022-10-15"},{"type":"extras","title":"Changelog - [1.1.6] - 2022-10-03","doc":"Fixed K8s.Resourse.label/2 : spec updated to accept label maps as a second argument #177 K8s.Discovery.Driver.File : Use conn.discovery_opts in file discovery driver ( #180 ) K8s.Client.DynamicHTTPProvider.request/5 : Fix converting PID to string inside error message ( #181 )","ref":"changelog.html#1-1-6-2022-10-03"},{"type":"extras","title":"Changelog - [1.1.5] - 2022-05-19","doc":"Fixed K8s.Client.watch_and_stream/2 : 410 Gone not rescued #159 K8s.Client.watch/3 : get operations should be transformed to list BEFORE retrieving the resource version #160 Changed K8s.Client.watch_and_stream/2 : Request BOOKMARK events and process them when watching resource collections. #159","ref":"changelog.html#1-1-5-2022-05-19"},{"type":"extras","title":"Changelog - [1.1.4] - 2022-03-15","doc":"Fix more authorization headers that are not keyword lists #148","ref":"changelog.html#1-1-4-2022-03-15"},{"type":"extras","title":"Changelog - [1.1.3] - 2022-03-13","doc":"Fixed Fix default value in K8s.Client.Runner.Watch.run/4 and K8s.Client.Runner.Watch.stream/3","ref":"changelog.html#1-1-3-2022-03-13"},{"type":"extras","title":"Changelog - [1.1.2] - 2022-03-13","doc":"Fixed Support for FQDN K8s API servers and Root CA chains #144 Wrong exception raised by K8s.Resource.from_file!/2 #137 , #143 K8s.Client.Runner.Watch.stream/3 - convert :get to :list operation with field selector. Make Logger metadata library: :k8s available at compile time.","ref":"changelog.html#1-1-2-2022-03-13"},{"type":"extras","title":"Changelog - [1.1.1] - 2022-03-01","doc":"Fixed Initialize authorization header as valid keyword list #142 Restore deprecated K8s.Sys.Event module.","ref":"changelog.html#1-1-1-2022-03-01"},{"type":"extras","title":"Changelog - [1.1.0] - 2022-02-21","doc":"Added K8s.Client.Runner.Watch.stream/3 - watches a resource and returns an elixir Stream of events #121 K8s.Client.apply/2 - Create a server-side apply operation Changed Handle generic kubernetes response Failure without a reason #120 Replace Notion with Telemetry and improve Logging #128 Deprecated K8s.Client.HTTPProvider.headers/2 was deprecated in favor of K8s.Client.HTTPProvider.headers/1 K8s.Client.DynamicHTTPProvider.headers/2 was deprecated in favor of K8s.Client.DynamicHTTPProvider.headers/1 Fixed Preserve namespace in get_to_list/1 #122 , #123 Fix obsolete doc on wait operation #118 Dialyzer errors with K8s.Client functions #119 Enable peer certificate authentication #127. Be aware, this will break configurations that have been using incorrect certificate(s) up to this point.","ref":"changelog.html#1-1-0-2022-02-21"},{"type":"extras","title":"Changelog - [1.0.0] - 2021-07-19","doc":"Added K8s.Resource.NamedList.access!/1 raises if item is missing K8s.Operation.put_label_selector/2 K8s.Operation.get_label_selector/1 Per connection http provider configuration K8s.Operation now uses keyword lists for query_params instead of maps Changed error tuples refactored away from binary and atom to exception modules removed dialyzer exceptions K8s.Conn.from_file/2 now returns an ok or error tuple K8s.Conn.from_service_account/N now returns an ok or error tuple K8s.Conn.t() is now the first argument in all runners. K8s.Operation.t() is now the second. deprecated K8s.http_provider/0 deprecated K8s.Discovery.default_opts/0 deprecated K8s.Discovery.default_driver/0 Refactored cluster names to strings K8s.Resource.NamedList.access/1 deals better with missing items now Removed K8s.Client.run/4, use K8s.Client.run/3 to pass options to HTTP provider Middleware moved to K8s.Conn.Middleware Removed K8s.Conn.lookup/1 config.exs based cluster registration is no longer supported, build K8s.Conn using K8s.Conn module environment variable based cluster registration has been removed and may be moved to an external library","ref":"changelog.html#1-0-0-2021-07-19"},{"type":"extras","title":"Changelog - [0.5.2] - 2020-07-31","doc":"Added Added auth exec support","ref":"changelog.html#0-5-2-2020-07-31"},{"type":"extras","title":"Changelog - [0.5.1] - 2020-07-17","doc":"Added K8s.Operation struct query_params field BasicAuth auth provider Deprecated HTTPoison options being passed to K8s.Client.Runner.base K8s.Operation.put_query_param/3 to add query parameters by key K8s.Operation.get_query_param/3 to get a query parameter by key DigitalOcean authentication K8s.Resource.NamedList.access/1 - Accessor for lists with named items (containers, env, ...) ( #82 ) Changed Refactored old references to cluster_name to conn","ref":"changelog.html#0-5-1-2020-07-17"},{"type":"extras","title":"Changelog - [0.5.0] - 2020-02-12","doc":"Added #42 Request middleware support #43 Just in time discovery: K8s.Discovery #44 Support for ad-hoc connections. K8s.Conn based functions. Build your own Conn at runtime or config mix/env vars. No more Cluster registry. K8s.Resource.from_file/2 and K8s.Resource.all_from_file/2 - non-exception versions Removed Boot time discovery K8s.Cluster.Discovery K8s.Cluster.base_url/1 Remove K8s.Cluster*","ref":"changelog.html#0-5-0-2020-02-12"},{"type":"extras","title":"Changelog - [0.4.0] - 2019-08-29","doc":"Changed Renamed K8s.Conf to K8s.Conn Refactored :conf configuration key to :conn","ref":"changelog.html#0-4-0-2019-08-29"},{"type":"extras","title":"Changelog - [0.3.2] - 2019-08-15","doc":"Added K8s.Selector.match_expressions?/2 to check if a resource matches expressions K8s.Selector.match_labels?/2 to check if a resource matches labels Changed K8s.Resource functions moved to submodule","ref":"changelog.html#0-3-2-2019-08-15"},{"type":"extras","title":"Changelog - [0.3.1] - 2019-08-15","doc":"Added text/plain response handling K8s.Selector - labelSelector support for K8s.Operation","ref":"changelog.html#0-3-1-2019-08-15"},{"type":"extras","title":"Changelog - [0.3.0] - 2019-07-29","doc":"Added K8s.Client.DynamicHTTPProvider to allow per-process registering of HTTP request handlers. K8s.Cluster.Discovery discovery interface K8s.Cluster.Discovery.api_versions/1 - queries a cluster for all apiVersions K8s.Cluster.Discovery.resource_definitions/1 - queries a cluster for all resource definitions K8s.Cluster.Discovery.HTTPDriver for discovery via k8s REST API K8s.Cluster.Discovery.FileDriver for discovery via a file, used for testing, shipped to help dependent libraries mock discovery Support for creating subresources Support for getting subresources Support for updating subresources Changed Refactored tests on DynamicHTTPProvider Refactored discovery to use K8s.Cluster.Discovery Set correct content-type for patch operations ( https://github.com/coryodaniel/k8s/issues/32 ) Refactored Operation.kind -&gt; Operation.name Group.cluster_key/2 -&gt; Group.lookup_key/2 K8s.Cluster.Group :ets data structure changed to map K8s.Cluster.Group module encompases access to :ets table Refactored Operation.resource -&gt; Operation.data. The term resource is a bit overloaded in this repo, since the operation is encapsulating the HTTP request, data feels a bit more clear. Refactored internal references to &quot;group version&quot; to &quot;api version&quot;","ref":"changelog.html#0-3-0-2019-07-29"},{"type":"extras","title":"Changelog - [0.2.13] - 2019-06-27","doc":"Added K8s.Cluster.base_url/1","ref":"changelog.html#0-2-13-2019-06-27"},{"type":"extras","title":"Changelog - [0.2.12] - 2019-06-26","doc":"Added First K8s.Client.Runner.Stream evaluation made lazy K8s.Resource.api_version/1","ref":"changelog.html#0-2-12-2019-06-26"},{"type":"extras","title":"Changelog - [0.2.11] - 2019-06-24","doc":"Added K8s.Resource.cpu/1 parses cpu resource requests/limits strings to number K8s.Resource.memory/1 parses cpu resource requests/limits strings to number","ref":"changelog.html#0-2-11-2019-06-24"},{"type":"extras","title":"Changelog - [0.2.10] - 2019-06-24","doc":"Added K8s.Client.Runner.Stream for producing elixir streams from k8s list results K8s 1.15 swagger file Changed Reversed pattern matching in functions from var=pattern to pattern=var Added make target for fetching master swagger before running tests","ref":"changelog.html#0-2-10-2019-06-24"},{"type":"extras","title":"Changelog - [0.2.9] - 2019-06-10","doc":"Added Kubernetes resources, groups, and CRDs are autodiscovered at boot time. No swagger file to include or override. Client supports standard HTTP calls, async batches, wait on status, and watchers Supports multiple clusters Supports multiple kubernetes APIs in the same runtime serviceaccount authentication token authentication certificate authentication auth-provider authetnicati Tested against kubernetes swagger specs: 1.10+ and master CRD support Kubernetes resource and version helper functions Kube config file parsing Pluggable auth providers","ref":"changelog.html#0-2-9-2019-06-10"},{"type":"extras","title":"Advanced","doc":"","ref":"advanced.html"},{"type":"extras","title":"Advanced - Custom Resource Definitions","doc":"Custom resources are discovered via the same mechanism as &quot;standard&quot; k8s resources and can be worked with as such: Listing the Greeting s from the hello operator . operation = K8s.Client . list ( &quot;hello-operator.example.com/v1&quot; , :greeting , [ namespace : &quot;default&quot; ] ) { :ok , greeting } = K8s.Client . run ( operation , :dev )","ref":"advanced.html#custom-resource-definitions"},{"type":"extras","title":"Advanced - Multiple Clusters","doc":"Copying a workloads between two clusters: Register a staging cluster: { :ok , staging_conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) Register a prod cluster: { :ok , prod_conn } = K8s.Conn . from_service_account ( ) # or from_file/2 Get a list of all deployments in the default prod namespace: { :ok , prod_conn } = K8s.Conn . from_service_account ( ) # or from_file/2 operation = K8s.Client . list ( &quot;apps/v1&quot; , :deployment , namespace : &quot;default&quot; ) { :ok , deployments } = K8s.Client . run ( prod_conn , operation ) Map the deployments to operations and async create on staging: { :ok , staging_conn } = K8s.Conn . from_service_account ( ) # or from_file/2 operations = Enum . map ( deployments , fn ( deployment ) -&gt; K8s.Client . create ( deployment ) end ) K8s.Client . async ( staging_conn , operations )","ref":"advanced.html#multiple-clusters"},{"type":"extras","title":"Advanced - Performing sub-resource operations","doc":"Subresource (eviction|finalize|bindings|binding|approval|scale|status) operations are created in the same way as standard operations using K8s.Operation.build/4 , K8s.Operation.build/5 , or any K8s.Client function. Getting a deployment's status: { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) operation = K8s.Client . get ( &quot;apps/v1&quot; , &quot;deployments/status&quot; , name : &quot;nginx&quot; , namespace : &quot;default&quot; ) { :ok , scale } = K8s.Client . run ( conn , operation ) Getting a deployment's scale: { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) operation = K8s.Client . get ( &quot;apps/v1&quot; , &quot;deployments/scale&quot; , [ name : &quot;nginx&quot; , namespace : &quot;default&quot; ] ) { :ok , scale } = K8s.Client . run ( conn , operation ) There are two forms for mutating subresources. Evicting a pod with a Pod map: { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) eviction = %{ &quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot; , &quot;kind&quot; =&gt; &quot;Eviction&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , } } # Here we use K8s.Resource.build/4 but this k8s resource map could be built manually or retrieved from the k8s API subject = K8s.Resource . build ( &quot;v1&quot; , &quot;Pod&quot; , &quot;default&quot; , &quot;nginx&quot; ) operation = K8s.Client . create ( subject , eviction ) { :ok , resp } = K8s.Client . run ( conn , operation ) Evicting a pod by providing details: { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) eviction = %{ &quot;apiVersion&quot; =&gt; &quot;policy/v1beta1&quot; , &quot;kind&quot; =&gt; &quot;Eviction&quot; , &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;nginx&quot; , } } subject = K8s.Client . create ( &quot;v1&quot; , &quot;pods/eviction&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx&quot; ] , eviction ) operation = K8s.Client . create ( subject , eviction ) { :ok , resp } = K8s.Client . run ( conn , operation )","ref":"advanced.html#performing-sub-resource-operations"},{"type":"extras","title":"Authentication (K8s.Conn.Auth)","doc":"k8s features pluggable authentication, but includes 5 strategies in the order of attempted application: K8s.Conn.Auth.Certificate certificate based authentication K8s.Conn.Auth.Token token based authentication K8s.Conn.Auth.AuthProvider implements a Kubernetes config file's auth-provider functionality. K8s.Conn.Auth.Exec implements a Kubernetes config file's exec functionality. K8s.Conn.Auth.BasicAuth username/password basic auth A few notes first: K8s.Conn.Auth.AuthProvider is itself an authentication strategy that allow shell calls to provide a Bearer Token. It's unfortunately named, but the names of the modules follow the key names in a Kubernetes config file. More on this strategy can be found here . The K8s.Conn struct encapsulates a connection to a cluster. It has the cluster address as well as how to authenticate to the cluster. K8s.Conn structs can be constructed manually, but there are a few helpers here to create one. The K8s.Conn.Auth.Token auth strategy is probably the simplest strategy to review as a reference implementation.","ref":"authentication.html"},{"type":"extras","title":"Authentication (K8s.Conn.Auth) - Custom Authentication Providers","doc":"Two things are required to implement a custom auth strategy: Implement the K8s.Conn.Auth behaviour for auth strategies. The first strategy to return an {:ok, K8s.Conn.Auth} struct will be chosen. Any that cannot authenticate the connection should return :skip . Implement the K8s.Conn.RequestOptions protocol which should create a RequestOptions struct. This struct is used to set HTTP Headers and SSL connection options. Looking at the Token example: Line 13 implements the case where this auth strategy would be able to generate request options Line 14 implements the default case where it cannot authenticate the request Lines 19-24 implement how to generate HTTP Headers and SSL options to be used by HTTPoison to make the HTTP requests.","ref":"authentication.html#custom-authentication-providers"},{"type":"extras","title":"Authentication (K8s.Conn.Auth) - Using a Custom Authentication Provider","doc":"Authentication providers are traversed in order. The first provider to return an K8s.Conn.Auth struct is used. Default providers are checked after any providers supplied to in the Mix config key :auth_providers : config :k8s , auth_providers : [ CustomProvider1 , CustomProvider2 ] This would result in authentication attempts in the following order: CustomProvider1 CustomProvider2 K8s.Conn.Auth.Certificate K8s.Conn.Auth.Token K8s.Conn.Auth.AuthProvider K8s.Conn.Auth.Exec K8s.Conn.Auth.BasicAuth For protocol and behavior implementation examples check out K8s.Conn.Auth implementations here .","ref":"authentication.html#using-a-custom-authentication-provider"},{"type":"extras","title":"Connections (K8s.Conn)","doc":"A connection ( K8s.Conn ) is the encapsulation of cluster information and authentication. They can be built using two helper functions ( K8s.Conn.from_file/2 , K8s.Conn.from_service_account/2 ) or by programmatically.","ref":"connections.html"},{"type":"extras","title":"Connections (K8s.Conn) - Building Connections","doc":"There are a few helper functions for creating K8s.Conn s, but they can also be created by using a struct. Using K8s.Conn.from_env/2 : K8s.Conn.from_env/2 takes an env variable name as binary (defaults to KUBECONFIG ). Bonny reads its value and forwards the call to K8s.Conn.from_file/2 . The options passed as second argument are the same as for K8s.Conn.from_file/2 . # Reads KUBECONFIG env varable: { :ok , conn } = K8s.Conn . from_env ( ) To pass the env variable explicitely and specify options: { :ok , conn } = K8s.Conn . from_env ( &quot;K8S_CONFIG_FILE&quot; , insecure_skip_tls_verify : true ) Using K8s.Conn.from_file/2 : K8s.Conn.from_file/2 accepts a keyword list as the second argument for selecting a cluster , user , and/or context from your kubeconfig file. { :ok , conn } = K8s.Conn . from_file ( &quot;/path/to/kube/config&quot; , context : &quot;your-context-name-here&quot; ) Using K8s.Conn.from_service_account/2 : If a path isn't provided for the service account, the default path is used /var/run/secrets/kubernetes.io/serviceaccount . { :ok , conn } = K8s.Conn . from_service_account ( ) Optionally the path can be specified: { :ok , conn } = K8s.Conn . from_service_account ( &quot;/path/to/service/account/directory&quot; ) Creating a K8s.Conn struct programmatically: For the use case of having an unbound number of connections (a multi-tenant K8s service) connections can be manually created. { :ok , cert } = K8s.Conn.PKI . cert_from_map ( cluster , base_path ) % K8s.Conn { url : &quot;https://ip-address-of-cluster&quot; , ca_cert : cert , auth : % K8s.Conn.Auth { } , insecure_skip_tls_verify : false , discovery_driver : K8s.Discovery.Driver.HTTP , discovery_opts : [ cache : true ] } See authentication and discovery for details on these options.","ref":"connections.html#building-connections"},{"type":"extras","title":"Discovery (K8s.Discovery)","doc":"k8s supports just-in-time discovery of cluster APIs and resource kinds. This is important because depending on the CRDs, Kubernetes version, and enabled APIs, URL paths can vary. The goal of the k8s library was to support multiple clusters without the need to generate code from Kubernetes swagger files. This makes the library more portable and easier to use with various clusters. K8s.Discovery is pluggable. It was designed in this manner to ease testing. The K8s.Discovery.Driver.HTTP driver is probably the only driver you will need to use in development and production. A file driver ( K8s.Discovery.Driver.File ) is also provided. This is used in the test suite to &quot;stub&quot; discovery without making HTTP requests. The file driver could also be used in the scenario that you want to limit calls to the Kubernetes masters either out to reduce the number of HTTP calls or for security if the master's API metadata is inaccessible ( kubectl api-versions , kubectl api-resources ).","ref":"discovery.html"},{"type":"extras","title":"Discovery (K8s.Discovery) - Using the Discovery module","doc":"Discovery is done automatically during HTTP requests, but the module can also be used directly. Available functions are: K8s.Discovery.versions/2 - list API versions of the cluster K8s.Discovery.resources/3 - list resource kinds of a specific API K8s.Discovery.url_for/2 - Generate the URL for a K8s.Operation on a specific K8s.Conn","ref":"discovery.html#using-the-discovery-module"},{"type":"extras","title":"Discovery (K8s.Discovery) - Setting the Default Driver","doc":"Drivers can be set via a Mix config. A default driver can be specified as well as a driver per registered connection. discovery_driver and discovery_opts control the default driver to use. If not set, the HTTP driver will be used with an empty keyword list. Below the file driver is set as the default using &quot;test/support/discovery/example.json&quot; as the configuration file (see Using the File Driver below). use Mix.Config config :k8s , discovery_driver : K8s.Discovery.Driver.File , discovery_opts : [ config : &quot;test/support/discovery/example.json&quot; ]","ref":"discovery.html#setting-the-default-driver"},{"type":"extras","title":"Discovery (K8s.Discovery) - Setting Drivers per Connection","doc":"Drivers can also be set per connection. { :ok , conn } = K8s.Conn . from_file ( &quot;....&quot; ) conn = % K8s.Conn { conn | discovery_driver : AlternateDriver }","ref":"discovery.html#setting-drivers-per-connection"},{"type":"extras","title":"Discovery (K8s.Discovery) - Using the HTTP Driver (K8s.Discovery.Driver.HTTP)","doc":"The HTTP driver is used by default. When a K8s.Operation is run calls to /api and /apis are made to discovery what resources, versions, and scope are supported for resources. The HTTP driver can also be used directly to explore API support. List supported versions: { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) K8s.Discovery.Driver.HTTP . versions ( conn ) [ &quot;v1&quot; , &quot;apps/v1&quot; , &quot;batch/v1&quot; ] List supported resources of an API version. { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) K8s.Discovery.Driver.HTTP . resources ( &quot;apps/v1&quot; , conn ) [ { &quot;kind&quot; : &quot;DaemonSet&quot; , &quot;name&quot; : &quot;daemonsets&quot; , &quot;namespaced&quot; : true , &quot;verbs&quot; : [ &quot;create&quot; , &quot;delete&quot; , &quot;deletecollection&quot; , &quot;get&quot; , &quot;list&quot; , &quot;patch&quot; , &quot;update&quot; , &quot;watch&quot; ] } , { &quot;kind&quot; : &quot;Deployment&quot; , &quot;name&quot; : &quot;deployments&quot; , &quot;namespaced&quot; : true , &quot;verbs&quot; : [ &quot;create&quot; , &quot;delete&quot; , &quot;deletecollection&quot; , &quot;get&quot; , &quot;list&quot; , &quot;patch&quot; , &quot;update&quot; , &quot;watch&quot; ] } # ... ]","ref":"discovery.html#using-the-http-driver-k8s-discovery-driver-http"},{"type":"extras","title":"Discovery (K8s.Discovery) - Using the File Driver (K8s.Discovery.Driver.File)","doc":"The file driver is primarily intended for testing. The format for a driver configuration file is a JSON file with API version as the key to a list of resource metadata. { &quot;v1&quot;: [ { &quot;kind&quot;: &quot;Namespace&quot;, &quot;name&quot;: &quot;namespaces&quot;, &quot;namespaced&quot;: false, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ], &quot;apps/v1&quot;: [ { &quot;kind&quot;: &quot;Deployment&quot;, &quot;name&quot;: &quot;deployments&quot;, &quot;namespaced&quot;: true, &quot;verbs&quot;: [ &quot;create&quot;, &quot;delete&quot;, &quot;deletecollection&quot;, &quot;get&quot;, &quot;list&quot;, &quot;patch&quot;, &quot;update&quot;, &quot;watch&quot; ] } ] }","ref":"discovery.html#using-the-file-driver-k8s-discovery-driver-file"},{"type":"extras","title":"Middleware (K8s.Middleware)","doc":"K8s.Middleware is associated to a K8s.Conn . By default the following K8s.Middleware.Stack is associated to all connections: K8s.Middleware.Request.Initialize K8s.Middleware.Request.EncodeBody","ref":"middleware.html"},{"type":"extras","title":"Middleware (K8s.Middleware) - Changing a Connection's Middleware","doc":"Given a registered K8s.Conn named &quot;foo&quot; the following example will add ExampleMiddleware to the end of the middleware stack { :ok , conn } = K8s.Conn . from_service_account ( ) new_stack = K8s.Middleware.Stack { request : [ MyFirstMiddleware , MySecondMiddleware ] } conn_with_new_middleware = % K8s.Conn { conn | middleware : new_stack }","ref":"middleware.html#changing-a-connection-s-middleware"},{"type":"extras","title":"Middleware (K8s.Middleware) - Writing Middleware","doc":"Request Middleware K8s.Middleware.Request is a behaviour and struct for encapsulating requests processed by the middleware stack. Middleware is expected to return {:ok, %Request{}} to continue processing or {:error, :my_error} to halt. The error in the error tuple can be an atom or a struct. It will automatically be wrapped in K8s.Middleware.Error during processing. To implement a piece of middleware, you need to define a function call/1 that accepts a K8s.Middleware.Request . The example below will automatically add labels to all :post requests. def call ( % Request { method : :post , body : body } = req ) do metadata = Map . get ( body , &quot;metadata&quot; , %{ } ) metadata_with_labels = Map . put ( metadata , &quot;labels&quot; , %{ &quot;env&quot; =&gt; &quot;prod&quot; } ) updated_body = Map . put ( body , &quot;metadata&quot; , metadata_with_labels ) request_with_labels = % Request { req | body : updated_body } { :ok , request_with_labels } end Response Middleware Response middleware has not been implemented at this time.","ref":"middleware.html#writing-middleware"},{"type":"extras","title":"Migrations","doc":"","ref":"migrations.html"},{"type":"extras","title":"Migrations - Migrating from &lt; 2.0.0","doc":"With version 2.0.0 some breaking changes were introduced in order to stabilize the library. Most of them are in the watch and stream functionalities. If you're using K8s.Client.DynamicHTTPProvider in your tests, you will have to change your mocks slightly. DynamicHTTPProvider The spec for K8s.Client.Provider.request/N and K8s.Client.Provider.stream/N were changed which reflects in your mock implementation if you're using K8s.Client.DynamicHTTPProvider . Concretely, the second variable is now of type %URI{} and contains the path and query_params. Migrating the path In most of the cases you're probably matching against the path that's passed to the function. In this case, you can just wrap the path by the struct: Old: defmodule K8sMock do def request ( :get , &quot;/api/v1/namespaces&quot; , _body , _headers , _opts ) do # code end end New: defmodule K8sMock do def request ( :get , % URI { path : &quot;/api/v1/namespaces&quot; } , _body , _headers , _opts ) do # code end end Migrating the query parameters If you're matching against query parameters sent to the function, you will have to match them in the URI as well: Old: defmodule K8sMock do def request ( :get , &quot;/api/v1/namespaces&quot; , _body , _headers , params : [ labelSelector : &quot;app=nginx&quot; ] ) do # code end end New: defmodule K8sMock do def request ( :get , % URI { path : &quot;/api/v1/namespaces&quot; , query : &quot;labelSelector=app%3Dnginx&quot; } , _body , _headers , _opts ) do # code end end Watch and Stream K8s.Client.watch/N was used to run a :list operation and watch it. With this release, there is now a :watch operation. K8s.Client.watch/N now is used to create a :watch operation which has to be passed to K8s.Client.stream/N . Also, the stream_to option was removed. See below. Streaming to another process - The stream_to option was removed Before 2.0.0 , you could pass the stream_to option to stream packets to a process. With the migration from HTTPoison to Mint, this option was removed. For :connect operations, K8s.Client.stream_to/N can be used as a replacement. Other operations will have to be streamed using K8s.Client.stream/N or go over K8s.Client.Runner.Base.stream_to/N . Examples :ok = K8s.Client . watch ( &quot;v1&quot; , &quot;ConfigMap&quot; , namespace : &quot;default&quot; ) |&gt; K8s.Client . put_conn ( conn ) |&gt; K8s.Client.Runner.Base . stream_to ( self ( ) ) receive do event -&gt; IO . inspect ( event ) end Pass a {pid, reference} tuple to get scoped messages: ref = make_ref ( ) :ok = K8s.Client . watch ( &quot;v1&quot; , &quot;ConfigMap&quot; , namespace : &quot;default&quot; ) |&gt; K8s.Client . put_conn ( conn ) |&gt; K8s.Client.Runner.Base . stream_to ( { self ( ) , ref } ) receive do { ^ ref , event } -&gt; IO . inspect ( event ) end Local Clusters and TLS Hostname Verification Local clusters are usually accessed via IP address so the hostname provided by the TLS certificate can't match the actual hostname (IP address). While somehow HTTPoison was OK with this, Mint declines the HTTPS connection. In order to make this work, you have to disable TLS peer verification. See also issue #203 { :ok , conn } = K8s.Conn . from_file ( ... ) conn = struct! ( conn , insecure_skip_tls_verify : true ) HTTPoison was removed Wherever you match against HTTPoison.* , you're gonna have to change your code. This might be the case in your error handlers. With 2.0.0 , all HTTP errors are wrapped in a K8s.Client.HTTPError exception struct.","ref":"migrations.html#migrating-from-2-0-0"},{"type":"extras","title":"Observability","doc":"","ref":"observability.html"},{"type":"extras","title":"Observability - Logging","doc":"All logs produced by this library should have library: :k8s as metadata which can be used in filters. K8s.Sys.Logger watches all telemetry events and logs them with :measurements and :metadata metadata entries which can be used in structured logs. In order to use it, you have to attach its telemetry handler. Call K8s.Sys.Logger.attach/0 in your application.ex : K8s.Sys.Logger . attach ( )","ref":"observability.html#logging"},{"type":"extras","title":"Observability - Telemetry","doc":"K8s.Sys.Telemetry provides a list of events executed by this library. Use it to attach handlers to them.","ref":"observability.html#telemetry"},{"type":"extras","title":"Observability - Tracing","doc":"Tracing has not been implemented yet.","ref":"observability.html#tracing"},{"type":"extras","title":"HTTP Operations (K8s.Operation)","doc":"K8s.Operation s are Kubernetes REST operations. They encapsulate all the details of an HTTP request except the server to perform them against. Many more client examples exist in the K8s.Client docs.","ref":"operations.html"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Creating a Deployment from a Map","doc":"resource = %{ &quot;apiVersion&quot; =&gt; &quot;apps/v1&quot; , &quot;kind&quot; =&gt; &quot;Deployment&quot; , &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } , &quot;name&quot; =&gt; &quot;nginx-deployment&quot; , &quot;namespace&quot; =&gt; &quot;default&quot; } , &quot;spec&quot; =&gt; %{ &quot;replicas&quot; =&gt; 3 , &quot;selector&quot; =&gt; %{ &quot;matchLabels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;template&quot; =&gt; %{ &quot;metadata&quot; =&gt; %{ &quot;labels&quot; =&gt; %{ &quot;app&quot; =&gt; &quot;nginx&quot; } } , &quot;spec&quot; =&gt; %{ &quot;containers&quot; =&gt; [ %{ &quot;image&quot; =&gt; &quot;nginx:1.7.9&quot; , &quot;name&quot; =&gt; &quot;nginx&quot; , &quot;ports&quot; =&gt; [ %{ &quot;containerPort&quot; =&gt; 80 } ] } ] } } } } operation = K8s.Client . create ( resource ) { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) { :ok , response } = K8s.Client . run ( conn , operation )","ref":"operations.html#creating-a-deployment-from-a-map"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Creating a Deployment from a YAML File","doc":"K8s.Resource provides YAML resource parsing and interpolation support as well as a few helper functions for accessing common Kubernetes resource fields. Given the YAML file priv/deployment.yaml : apiVersion: apps/v1 kind: Deployment metadata: name: &lt;%= name %&gt;-deployment namespace: &lt;%= namespace %&gt; labels: app: &lt;%= name %&gt; spec: replicas: 3 selector: matchLabels: app: &lt;%= name %&gt; template: metadata: labels: app: &lt;%= name %&gt; spec: containers: - name: &lt;%= name %&gt; image: &lt;%= image %&gt; ports: - containerPort: 80 opts = [ namespace : &quot;default&quot; , name : &quot;nginx&quot; , image : &quot;nginx:nginx:1.7.9&quot; ] resource = K8s.Resource . from_file! ( &quot;priv/deployment.yaml&quot; , opts ) operation = K8s.Client . create ( resource ) { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) { :ok , deployment } = K8s.Client . run ( conn , operation )","ref":"operations.html#creating-a-deployment-from-a-yaml-file"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Listing Deployments","doc":"In a given namespace: operation = K8s.Client . list ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : &quot;prod&quot; ) { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) { :ok , deployments } = K8s.Client . run ( conn , operation ) Across all namespaces: operation = K8s.Client . list ( &quot;apps/v1&quot; , &quot;Deployment&quot; , namespace : :all ) { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) { :ok , deployments } = K8s.Client . run ( conn , operation ) Note: K8s.Client.list will return a map . The list of resources will be under &quot;items&quot; .","ref":"operations.html#listing-deployments"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Using labelSelector with List Operations","doc":"K8s.Selector supports programatically building Kubernetes labelSelector s. { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) operation = K8s.Client . list ( &quot;apps/v1&quot; , :deployments ) |&gt; K8s.Selector . label ( { &quot;app&quot; , &quot;nginx&quot; } ) |&gt; K8s.Selector . label_in ( { &quot;environment&quot; , [ &quot;qa&quot; , &quot;prod&quot; ] } ) K8s.Client . run ( conn , operation )","ref":"operations.html#using-labelselector-with-list-operations"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Getting a Deployment","doc":"{ :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) operation = K8s.Client . get ( &quot;apps/v1&quot; , :deployment , [ namespace : &quot;default&quot; , name : &quot;nginx-deployment&quot; ] ) { :ok , deployment } = K8s.Client . run ( conn , operation )","ref":"operations.html#getting-a-deployment"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Watch Operations (K8s.Client.Runner.Watch)","doc":"Watch operations use the Kubernetes Watch API to stream added , modified , and deleted as they occur. To get a stream of events: operation = K8s.Client . watch ( &quot;apps/v1&quot; , :deployment , namespace : :all ) { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) { :ok , event_stream } = K8s.Client . stream ( conn , operation )","ref":"operations.html#watch-operations-k8s-client-runner-watch"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Wait on a Resource (K8s.Client.Runner.Wait)","doc":"The wait runner permits read operations to be made and block until a certain state is met in Kubernetes. This follow example will wait 60 seconds for the field status.succeeded to equal 1 . operation = K8s.Client . get ( &quot;batch/v1&quot; , :job , namespace : &quot;default&quot; , name : &quot;database-migrator&quot; ) wait_opts = [ find : [ &quot;status&quot; , &quot;succeeded&quot; ] , eval : 1 , timeout : 60 ] { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) { :ok , job } = K8s.Client . wait_until ( conn , operation , wait_opts ) :find and :eval also accept functions to apply to check success.","ref":"operations.html#wait-on-a-resource-k8s-client-runner-wait"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Async Batch Operations (K8s.Client.Runner.Async)","doc":"An async runner is provided for running operations in parallel. All operations are fired async and their results are returned. Processing does not halt if an error occurs for one operation. operation1 = K8s.Client . get ( &quot;v1&quot; , &quot;Pod&quot; , namespace : &quot;default&quot; , name : &quot;pod-1&quot; ) operation2 = K8s.Client . get ( &quot;v1&quot; , &quot;Pod&quot; , namespace : &quot;default&quot; , name : &quot;pod-2&quot; ) { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) results = K8s.Client . async ( conn , [ operation1 , operation2 ] ) results will be a list of :ok and :error tuples.","ref":"operations.html#async-batch-operations-k8s-client-runner-async"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - List Operations as Elixir Streams (K8s.Client.Runner.Stream)","doc":"A stream runner is provided to automatically handle pagination in K8s.Client.list/3 operations. operation = K8s.Client . list ( &quot;v1&quot; , &quot;Pod&quot; , namespace : :all ) { :ok , conn } = K8s.Conn . from_file ( &quot;path/to/kubeconfig.yaml&quot; ) conn |&gt; K8s.Client . stream ( operation ) |&gt; Stream . filter ( &amp; my_filter_function? / 1 ) |&gt; Stream . map ( &amp; my_map_function? / 1 ) |&gt; Enum . into ( [ ] )","ref":"operations.html#list-operations-as-elixir-streams-k8s-client-runner-stream"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Connect to pods/exec subresource and execute commands","doc":"Use the :connect operation to connect to the pods/exec subresource and execute commands. A :connect operation is created with K8s.Client.connect/N . When connecting to pods/exec , be sure to pass the command you want to run in the options. Waiting for command termination If you want to run a command that terminates and wait for it, pass the :connect operation to K8s.Client.run/N . { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) op = K8s.Client . connect ( &quot;v1&quot; , &quot;pods/exec&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx-8f458dc5b-zwmkb&quot; ] , command : [ &quot;/bin/sh&quot; , &quot;-c&quot; , &quot;nginx -t&quot; ] ) { :ok , response } = K8s.Client . run ( conn , op ) Opening long-lasting connections (e.g. a shell) and sending messages to pods If you send a command that does not terminate (e.g. /bin/sh ) or one that takes long to terminate, you can open the connection in a separate process and stream the response. Further, you can send/2 messages to that process (e.g. further commands). See the example below. { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) op = K8s.Client . connect ( &quot;v1&quot; , &quot;pods/exec&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx-8f458dc5b-zwmkb&quot; ] , command : [ &quot;/bin/sh&quot; ] ) parent_process = self ( ) task = Task . async ( fn -&gt; { :ok , stream } = K8s.Client . stream ( conn , op ) stream |&gt; Stream . map ( &amp; send ( parent_process , &amp;1 ) ) |&gt; Stream . run ( ) end ) # wait for connection to be established receive ( do : ( :open -&gt; :ok ) send ( task . pid , { :stdin , ~s(echo &quot;hello world&quot; \\n ) } ) # you receive &quot;hello world&quot; on stdout receive ( do : ( { :stdout , message } -&gt; IO . puts ( message ) ) # close the connection, the task will terminate. send ( task . pid , :close ) Options command - required for running commands container - if a pod runs multiple containers, you have to specify the container to run the command in. stdin - enable stdin (defaults to true ) stdout - enable stdout (defaults to true ) stderr - enable stderr (defaults to true ) tty - stdin is a TTY (defaults to false ) { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) op = K8s.Client . connect ( &quot;v1&quot; , &quot;pods/exec&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx-8f458dc5b-zwmkb&quot; ] , command : [ &quot;/bin/sh&quot; , &quot;-c&quot; , &quot;nginx -t&quot; ] , container : &quot;main&quot; , tty : true ) { :ok , response } = K8s.Client . run ( conn , op )","ref":"operations.html#connect-to-pods-exec-subresource-and-execute-commands"},{"type":"extras","title":"HTTP Operations (K8s.Operation) - Connect to pods/log subresource to read logs from Pods","doc":"Use the :connect operation to connect to the pods/log subresource. A :connect operation is created with K8s.Client.connect/N . Options Refer to the Kubernetes documentation for documentation on these options. container follow - Use with K8s.Client.stream/N or K8s.Client.stream_to/N . insecureSkipTLSVerifyBackend limitBytes pretty previous sinceSeconds tailLines timestamps { :ok , conn } = K8s.Conn . from_file ( &quot;~/.kube/config&quot; ) { :ok , stream } = K8s.Client . connect ( &quot;v1&quot; , &quot;pods/log&quot; , [ namespace : &quot;default&quot; , name : &quot;nginx-8f458dc5b-zwmkb&quot; ] , command : [ &quot;/bin/sh&quot; , &quot;-c&quot; , &quot;nginx -t&quot; ] , container : &quot;main&quot; , follow : true ) |&gt; K8s.Client . put_conn ( conn ) |&gt; K8s.Client . stream ( )","ref":"operations.html#connect-to-pods-log-subresource-to-read-logs-from-pods"},{"type":"extras","title":"Testing","doc":"k8s supports a few mechanisms to stub Kubernetes HTTP requests when developing or testing locally.","ref":"testing.html"},{"type":"extras","title":"Testing - Mocking API Version and Resource Discovery","doc":"K8s does resource discovery of the Kubernetes API before running K8s.Operation s. When testing if a Kubernetes cluster isn't available you can use the module K8s.Discovery.Driver.File to stub Kubernetes api-resource and api-versions responses. The mock used in the test suite is here . The driver can be set for all clusters or per-cluster: config :k8s , discovery_driver : K8s.Discovery.Driver.File , discovery_opts : [ config : &quot;test/support/discovery/example.json&quot; ] { :ok , conn } = K8s.Conn . from_file ( &quot;....&quot; ) conn = % K8s.Conn { conn | discovery_driver : AlternateDriver }","ref":"testing.html#mocking-api-version-and-resource-discovery"},{"type":"extras","title":"Testing - Mocking HTTP Responses of K8s.Operations in your application","doc":"K8s ships with a K8s.Client.DynamicHTTPProvider for stubbing HTTP responses to kubernetes API requests. This provider is used throughout the test suite for mocking HTTP responses. To enable the dynamic HTTP provider it must be turned on in your config.exs : config :k8s , http_provider : K8s.Client.DynamicHTTPProvider defmodule MyApp.ResourceTest do use ExUnit.Case , async : true defmodule K8sMock do @namespaces_path &quot;/api/v1/namespaces&quot; def request ( :get , % URI { path : @namespaces_path } , _ , _ , _ ) do namespaces = [ %{ &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;default&quot; } } ] body = Jason . encode! ( namespaces ) { :ok , % HTTPoison.Response { status_code : 200 , body : body } } end end setup do DynamicHTTPProvider . register ( self ( ) , __MODULE__ . K8sMock ) end test &quot;gets namespaces&quot; do conn = % K8s.Conn { } # set up your conn operation = K8s.Client . get ( &quot;v1&quot; , :namespaces ) assert { :ok , namespaces } = K8s.Client . run ( conn , operation ) assert namespaces == [ %{ &quot;metadata&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;default&quot; } } ] end end To see advanced examples of usage, check out these examples in the test suite: client/runner/base client/runner/stream client/runner/stream/watch discovery","ref":"testing.html#mocking-http-responses-of-k8s-operations-in-your-application"},{"type":"extras","title":"Testing - Integration Testing","doc":"A Makefile is included for help with integration testing against k3s. Run make help for a list of commands: test . integration Run integration tests using k3d ` make cluster ` test . watch Run all tests with mix . watch test Run all tests Integration environment variables KUBECONFIG path to kubeconfig file for integration tests, default: &quot;./integration.yaml&quot; TEST_WAIT_TIMEOUT number of seconds to timeout running Wait integration tests, default: 5","ref":"testing.html#integration-testing"}]